////////////////////
//HeaderBean
// returns FCS header information for a given file
///////////////////

package FACS.Plot;

import FACS.FACSData;
import FACS.FCSTools;
import FACS.XMLFiles;
import FACS.Plot.PlotServlet.TimedConcurrentHashMap;

import java.io.*;
import java.util.Hashtable;
import java.util.concurrent.locks.ReentrantReadWriteLock;
import java.beans.XMLDecoder;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.Context;

public class Headerlet extends HttpServlet {
	private static String ROOT;
	private static ReentrantReadWriteLock rw = new ReentrantReadWriteLock();
	public static TimedConcurrentHashMap annosCache;

	public static final java.beans.ExceptionListener el = new java.beans.ExceptionListener() {
			public void exceptionThrown(Exception exception) {
				exception.printStackTrace();
			}
		};

	/*Hashtable annos;
	File directory, filedirectory;
	
	long annosModified;*/

	public Headerlet() {
		super();

		try {
			Context c = new javax.naming.InitialContext();
			ROOT = (String)c.lookup("java:comp/env/fcsroot");
		} catch (javax.naming.NamingException ne) {
			ne.printStackTrace();
			ROOT = "";
		}
		/*directory = null;
		filedirectory = null;
		annos = null;*/
		
		annosCache = new TimedConcurrentHashMap(20);
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		/*HttpSession session = request.getSession();
		
		File tempdir = new File(ROOT,request.getParameter("directory"));
		rw.readLock().lock();
		File directory = (File)session.getAttribute("directory");
		File filedirectory = (File)session.getAttribute("filedirectory");
		if(directory == null || !tempdir.equals(directory) || session.getAttribute("annos") == null) {
			rw.readLock().unlock();
			rw.writeLock().lock();
			directory = tempdir;
			filedirectory = new File(ROOT,XMLFiles.getFileLink(ROOT,request.getParameter("directory")));
			session.setAttribute("directory",directory);
			session.setAttribute("filedirectory",filedirectory);
			initialize(session);
			rw.writeLock().unlock();
			rw.readLock().lock();
		}
		
		if(wasModified(directory,((Long)session.getAttribute("annosModified")).longValue())) {
			rw.readLock().unlock();
			rw.writeLock().lock();
			initialize(session);
			rw.writeLock().unlock();
			rw.readLock().lock();
		}
		Hashtable annos = (Hashtable)session.getAttribute("annos");
		rw.readLock().unlock();*/
		
		File directory = new File(ROOT,request.getParameter("directory"));
		File filedirectory = new File(ROOT,XMLFiles.getFileLink(ROOT,request.getParameter("directory")));
		
		rw.readLock().lock();
		Hashtable annos;
		if((annos = (Hashtable)annosCache.get(directory)) == null) {
			rw.readLock().unlock();
			rw.writeLock().lock();
			if((annos = (Hashtable)annosCache.get(directory)) == null) {
				annos = initialize(directory);
				annosCache.put(directory,annos);
			}
			rw.writeLock().unlock();
			rw.readLock().lock();
		} else if(wasModified(directory,((Long)annos.get("annosModified")).longValue())) {
			rw.readLock().unlock();
			rw.writeLock().lock();
			annos = initialize(directory);
			annosCache.put(directory,annos);
			rw.writeLock().unlock();
			rw.readLock().lock();
		}
		rw.readLock().unlock();
		

		File f = new File(filedirectory,request.getParameter("file"));
		
		/*response.setContentType("applet/octet-stream");
		byte[] h = getHeader(f);
		response.getOutputStream().write(rightJustify(h.length,8).getBytes());
		response.getOutputStream().write(getHeader(f));*/

		byte[] header = FCSTools.getFCSHeader(f);
		FACSData fd = FCSTools.readHeader(0,request.getParameter("file"),header);

		fd.setAnnotations((Hashtable)annos.get(fd.filename));

		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(response.getOutputStream()));
		try {
			oos.writeObject(fd);
			oos.flush();
		} catch (IOException ioe) {
			ioe.printStackTrace();
			return;
		}
	}

	public Hashtable initialize(File directory) {
		Hashtable annos = new Hashtable();
		File xml = new File(directory, "annos.xml");
		try {
			XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
			d.setExceptionListener(el);
			try {
				annos = (Hashtable)d.readObject();
				annos.put("annosModified",new Long(xml.lastModified()));
			} finally {
				d.close();
			}
		} catch (FileNotFoundException fnfe) {
		}
		return annos;
	}
	
	public boolean wasModified(File directory, long annosModified) {
		File xml = new File(directory, "annos.xml");
		if(annosModified < xml.lastModified())
			return true;
		return false;
	}

	/*public int getInt(byte[] b) throws NumberFormatException {
        String s = new String(b);
        Integer i = new Integer(s.trim());
        return i.intValue();
    }

	public String rightJustify(int val, int size) {
		String s = val+"";
		while(s.length() < size) {
			s = " "+s;
		}
		return s;
	}*/

}