////////////////////
// Class that defines a "population" (i.e. gate set & sample set to gate)
////////////////////

package FACS;

import java.util.Vector;

public class Population implements java.io.Serializable, Cloneable {
	private static final long serialVersionUID = 1L;
	String name;
	Vector gates, files;
	boolean comp; //compensate when gating? [ironically, compensation samples have comp=false]

	public Population() {
	}

	public Population(String name, Vector gates, Vector files, boolean comp) {
		this.name = name;
		this.gates = gates;
		this.files = files;
		this.comp = comp;
	}

	public String toString() {
		if(comp)
			return getName();
		else
			return getName()+" (No Comp)";
	}

	public Population deriveCompensated() {
		return new Population(name,gates,files,true);
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setGates(Vector gates) {
		this.gates = gates;
	}

	public void setFiles(Vector files) {
		this.files = files;
	}

	public void setComp(boolean comp) {
		this.comp = comp;
	}

	public String getName() {
		return name;
	}

	public Vector getGates() {
		return gates;
	}

	public Vector getFiles() {
		return files;
	}

	public boolean isComp() {
		return comp;
	}

	public Object clone() {
		return new Population(name, (Vector)gates.clone(), (Vector)files.clone(), comp);
	}
}
