////////////////////////////
// Client side (applet) of web-interface multiple file upload program
//
// by Mark Hammer
////////////////////////////

package FACS.Upload;

import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import java.awt.Color;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.Hashtable;
import java.util.Iterator;
import java.awt.Dimension;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import java.awt.dnd.*;
import java.awt.datatransfer.*;

public class UploadClient extends JApplet implements ActionListener, ListSelectionListener {
	/*public static String HOST;
	public static int port;*/
	
	public static String SERVLET_URL;

	JFileChooser fc;

	JPanel p;
	JTextField /*tfUser, tfPass,*/ tfExpt;
	String username;

	Hashtable dirs;
	JList ls1, ls2;

	DroppableList dlFiles;

	public void init() {
		/*HOST = getParameter("host");
		if(HOST == null)
			HOST = getCodeBase().getHost();
		String p = getParameter("port");
		if(p == null)
			p = "4444";
		port = new Integer(p).intValue();*/
		
		SERVLET_URL = "servlets/UploadServlet";
		if(getParameter("servlet") != null)
			SERVLET_URL = getParameter("servlet");
		if(getParameter("user") != null)
			username = getParameter("user");
		else
			return; //okay, this is being ugly.. but we really shouldn't run into this problem

		dirs = new Hashtable();
		createGUI();
    }

	public void createGUI() {
		setBackground(Color.white);
		p = new JPanel();
		p.setBackground(Color.white);


		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));

		/*JPanel pU = new JPanel();
		tfUser = new JTextField(10);
		pU.add(new JLabel("User name: "));
		pU.add(tfUser);
		p.add(pU);
		JPanel pP = new JPanel();
		tfPass = new JPasswordField(10);
		pP.add(new JLabel("Password: "));
		pP.add(tfPass);
		p.add(pP);*/
		JPanel pE = new JPanel();
		tfExpt = new JTextField(12);
		pE.add(new JLabel("Experiment: "));
		pE.add(tfExpt);
		p.add(pE);

		JButton bChooser = new JButton("Browse...");
		bChooser.setActionCommand("chooser");
		bChooser.addActionListener(this);
		p.add(bChooser);

		dlFiles = new DroppableList();
		dlFiles.setVisibleRowCount(-1);
		JScrollPane spList = new JScrollPane(dlFiles);
		spList.setPreferredSize(new Dimension(200,200));
		spList.setBorder(BorderFactory.createTitledBorder("Files"));
		p.add(spList);

		JButton bOk = new JButton("Upload");
		bOk.setActionCommand("okay");
		bOk.addActionListener(this);
		p.add(bOk);

		getContentPane().add(p);
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand().equals("chooser")) {
			if(fc == null)
				fc = new JFileChooser();
			fc.setMultiSelectionEnabled(true);
			if(fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
				File[] f = fc.getSelectedFiles();
				for(int i = 0; i < f.length; i++) {
					((DefaultListModel)dlFiles.getModel()).addElement(f[i].getAbsolutePath());
				}
			}
		}
		if(e.getActionCommand().equals("okay")) {
			if(/*tfUser.getText().length() != 0 &&*/ tfExpt.getText().length() != 0) {
				Object[] f = (((DefaultListModel)dlFiles.getModel()).toArray());
				int s = uploadFiles(f);
				
				p.removeAll();

				if(s == -1)
					p.add(new JLabel("Upload failed"));
				else
					p.add(new JLabel("Upload successful ("+s+"/"+f.length+" files)"));

				JPanel pDirs = new JPanel();
				ls1 = new JList(dirs.keySet().toArray());
				ls1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
				ls1.setVisibleRowCount(-1);
				ls1.addListSelectionListener(this);
				JScrollPane spList1 = new JScrollPane(ls1);
				spList1.setPreferredSize(new Dimension(150,200));
				spList1.setBorder(BorderFactory.createTitledBorder("Directory"));
				pDirs.add(spList1);

				ls2 = new JList();
				ls2.setVisibleRowCount(-1);
				JScrollPane spList2 = new JScrollPane(ls2);
				spList2.setPreferredSize(new Dimension(150,200));
				spList2.setBorder(BorderFactory.createTitledBorder("Files"));
				pDirs.add(spList2);

				p.add(pDirs);

				validate();
				repaint();
			}
		}
	}

	public void valueChanged(ListSelectionEvent lse) {
        if(lse.getValueIsAdjusting())
            return;

		String files = (String)dirs.get(ls1.getSelectedValue());
		String[] fls = files.split("\t");
		ls2.setListData(fls);
	}

	public int uploadFiles(Object[] f) {
		int j = 0;
		File ff;
		for(int i = 0; i < f.length; i++) {
			try {
				String fixings = "?";
				fixings += "user="+URLEncoder.encode(username,"UTF-8"); //tfUser.getText()
				//fixings += "&pass="+URLEncoder.encode(tfPass.getText(),"UTF-8");
				fixings += "&expt="+URLEncoder.encode(tfExpt.getText(),"UTF-8");
				ff = new File((String)f[i]);
				getAppletContext().showStatus("Uploading file "+ff.getName());
				fixings += "&file="+URLEncoder.encode(ff.getName(),"UTF-8");
				fixings += "&size="+ff.length();
				URL servletURL = new URL(getCodeBase(),SERVLET_URL+fixings);
				HttpURLConnection servlet = (HttpURLConnection)servletURL.openConnection();
				servlet.setFixedLengthStreamingMode((int)ff.length());
				servlet.setDoInput(true);
				servlet.setDoOutput(true);
	
				servlet.setUseCaches (false); //don't cache connection
				servlet.setDefaultUseCaches (false);
	
				servlet.setRequestProperty("Content-Type","application/octet-stream");
				
				BufferedInputStream bis = new BufferedInputStream(new FileInputStream(ff), 65536);
				BufferedOutputStream bos = new BufferedOutputStream(servlet.getOutputStream(), 65536);
				byte[] b = new byte[65536];
				int written = 0;
				while(written < ff.length()) {
					int l = bis.read(b);
					bos.write(b,0,l);
					written += l;
					bos.flush();
				}
				bos.flush();
				bos.close();
				bis.close();
				
				if(i != f.length-1) {
					bis = new BufferedInputStream(servlet.getInputStream());
					bis.read();
				} else {
					ObjectInputStream ois = new ObjectInputStream(new BufferedInputStream(servlet.getInputStream()));
					try {
						dirs = (Hashtable)ois.readObject();
					} catch (ClassNotFoundException cnfe) {
						cnfe.printStackTrace();
					}
					ois.close();
				}
				
				j++;
			} catch(IOException ioe) {
				ioe.printStackTrace();
			}
		}
		getAppletContext().showStatus("Transfers done.");
		
		return j;
		
		/*boolean b;
		int s = 0;
		byte[] bF;
		try {
			PrintWriter out = null;
			BufferedReader in = null;

			System.out.println(HOST);
			Socket socket = new Socket();
			socket.connect(new InetSocketAddress(HOST, port), 2000);
			out = new PrintWriter(socket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(
                                        socket.getInputStream()));

			b = true;
			while(b) {
				//login
				if(!in.readLine().equals("UploadServer"))
					break;
				if(!in.readLine().startsWith("user"))
					break;
				out.println(tfUser.getText());
				if(!in.readLine().startsWith("pass"))
					break;
				out.println(tfPass.getText());
				if(!in.readLine().equals("good"))
					break;
				if(!in.readLine().startsWith("expt"))
					break;
				out.println(tfExpt.getText());
				if(!in.readLine().equals("good"))
					break;
				//send files
				File ff;
				FileInputStream fis; FileChannel fc; //MappedByteBuffer mbb; ByteBuffer bb;
				for(int i = 0; i < f.length; i++) {
					ff = new File((String)f[i]);
					out.println(ff.getName());
					getAppletContext().showStatus("Transferring "+ff.getName());
					int port = new Integer(in.readLine()).intValue();
					if(port != -1) { //file already exists
						//Socket data = new Socket(HOST, port);
						SocketChannel data = SocketChannel.open();
						data.connect(new InetSocketAddress(HOST,port));
						try {
							fis = new FileInputStream(ff);
							fc = fis.getChannel();
							long size = fc.size();
							out.println(size);
							
							//mbb = fc.map(FileChannel.MapMode.READ_ONLY,0,fc.size());
							//bb = mbb.asReadOnlyBuffer();
							//bF = new byte[(int)ff.length()];
							//System.out.println(System.currentTimeMillis());
							//out.println("reading");
							long read = 0;
							long buffer = 65536;
							while(read < size) {
								read += fc.transferTo(read,buffer,data);
								//System.out.println(read);
							}
							/*while((read=fis.read(bF)) > 0) {
								data.getOutputStream().write(bF,0,read);
							}*/
							/*data.getOutputStream().flush();*/
							/*fis.close();
							//System.out.println(System.currentTimeMillis());
							//out.println("writing");
							out.println("done");
							//System.out.println(System.currentTimeMillis());
							s++;
						} catch (IOException ioe) {
							ioe.printStackTrace();
							data.close();
						}
						out.println("EOF");
						data.close();
					}
				}
				getAppletContext().showStatus("Transfers done.");
				out.println("bye");
				//get updated directory structure
				String line = "";
				while((line=in.readLine()) != null) {
					String[] parts = line.split(":");
					dirs.put(parts[0],parts[1]);
				}

				b = false;
			}

			bF = null;
			out.close();
			in.close();
			socket.close();
		}catch (java.net.UnknownHostException e) {
            System.err.println("Don't know about host: "+HOST);
            return -1;
        } catch (IOException ioe) {
			ioe.printStackTrace();
			return -1;
		}
		if(!b)
			return s;
		else
			return -1;*/
	}

	public void start() {
    }

    public void stop() {
    }

    public void destroy() {
    }
}

class DroppableList extends JList implements DropTargetListener { //, DragSourceListener, DragGestureListener {
	DropTarget dropTarget = new DropTarget (this, this);
	//DragSource dragSource = DragSource.getDefaultDragSource();

	public DroppableList() {
		//dragSource.createDefaultDragGestureRecognizer(this, DnDConstants.ACTION_COPY_OR_MOVE, this);
		setModel(new DefaultListModel());
	}
	

	public void dragEnter (DropTargetDragEvent dropTargetDragEvent) {
		dropTargetDragEvent.acceptDrag (DnDConstants.ACTION_COPY_OR_MOVE);
	}

	public void dragExit (DropTargetEvent dropTargetEvent) {}
	public void dragOver (DropTargetDragEvent dropTargetDragEvent) {}
	public void dropActionChanged (DropTargetDragEvent dropTargetDragEvent){}

	public synchronized void drop (DropTargetDropEvent dropTargetDropEvent) {
		try {
			Transferable tr = dropTargetDropEvent.getTransferable();
			if (tr.isDataFlavorSupported (DataFlavor.javaFileListFlavor)) {
				dropTargetDropEvent.acceptDrop (DnDConstants.ACTION_COPY_OR_MOVE);
				java.util.List fileList = (java.util.List)tr.getTransferData(DataFlavor.javaFileListFlavor);
				Iterator iterator = fileList.iterator();
				while (iterator.hasNext()) {
					File file = (File)iterator.next();
					((DefaultListModel)getModel()).addElement(file.getAbsolutePath());
				}
				dropTargetDropEvent.getDropTargetContext().dropComplete(true);
			} else {
			dropTargetDropEvent.rejectDrop();
			}
		} catch (IOException io) {
			io.printStackTrace();
			dropTargetDropEvent.rejectDrop();
		} catch (UnsupportedFlavorException ufe) {
			ufe.printStackTrace();
			dropTargetDropEvent.rejectDrop();
		}
	}
}