////////////////////////////
// Server side of web-interface multiple file upload program
//
// by Mark Hammer
////////////////////////////

package FACS.Upload;

import java.io.*;
import java.util.Hashtable;

import javax.naming.Context;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class UploadServlet extends HttpServlet {
	Hashtable hpass;

	private static String ROOT;

    public UploadServlet() {
    	super();
    	try {
			Context c = new javax.naming.InitialContext();
			ROOT = (String)c.lookup("java:comp/env/fcsroot");
		} catch (javax.naming.NamingException ne) {
			ne.printStackTrace();
			ROOT = "";
		}
		readPass();
    }
    
    public void readPass() {
    	hpass = new Hashtable();
    	try {
	    	RandomAccessFile raf = new RandomAccessFile(new File(ROOT,"pass.txt"),"r");
			String line = ""; 
			while((line=raf.readLine()) != null) {
				String[] pair = line.split("\t");
				hpass.put(pair[0],pair[1]);
			}
			
			raf.close();
    	} catch(IOException ioe) {
    		ioe.printStackTrace();
    	}
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//we're going to upload a given file, then send directory structure (client can ignore)
		String user = request.getParameter("user");
		//String pass = request.getParameter("pass");
		if(!hpass.containsKey(user))
			return;
		/*if(!((String)hpass.get(user)).equals(pass)) //from now on, we'll assume that the password is correct (the user.jsp would have blocked them otherwise)
			return;*/
		File dir1 = new File(ROOT, user);
		File directory = new File(dir1, request.getParameter("expt"));
		if(!directory.exists()) {
			if(!directory.mkdir()) {
				System.out.println("error - cannot make directory "+directory.getName());
				return;
			}
		}
		File f = new File(directory, request.getParameter("file"));
		if(f.exists()) {
			listDirectory(dir1,response);
			return;
		}
		int total = new Integer(request.getParameter("size")).intValue();
		BufferedInputStream bis = new BufferedInputStream(request.getInputStream(), 65536);
		BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(f), 65536);
		byte[] b = new byte[65536];
		int written = 0;
		while(written < total) {
			int l = bis.read(b);
			while(l == -1) {
				try {
					Thread.sleep(100);
				} catch (InterruptedException ie) {
				}
				l = bis.read(b);
			}
			bos.write(b,0,l);
			written += l;
		}
		bos.close();
		listDirectory(dir1,response);
	}

	private void listDirectory(File directory, HttpServletResponse response) throws IOException {
		Hashtable dirs = new Hashtable();
		String[] d1 = directory.list(); File dir2;
		for(int i = 0; i < d1.length; i++) {
			String contents = "";
			dir2 = new File(directory, d1[i]);
			String[] d2 = dir2.list();
			for(int j = 0; j < d2.length; j++) {
				contents += d2[j]+"\t";
			}
			dirs.put(d1[i],contents);
		}
		
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(response.getOutputStream()));
		try {
			oos.writeObject(dirs);
			oos.flush();
		} catch (IOException ioe) {
			ioe.printStackTrace();
			return;
		}
		oos.close();
	}

	/*public void run() {
		try {
			PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
			BufferedReader in = new BufferedReader(
						new InputStreamReader(
						socket.getInputStream()));

			String inputLine = "", outputLine = "";
			boolean b = true;
			while(b) {
				//login
				out.println("UploadServer");
				out.println("user: ");
				String user = in.readLine();
				File dir = new File(directory,user);
				if(!dir.exists() || !dir.isDirectory())
					break;
				out.println("pass: ");
				String passwd = in.readLine();
				boolean good = false;
				/**/
				/*if(((String)pass.get(user)).equals(passwd))
					good=true;
				if(!good) {
					out.println("error in username/password");
					break;
				}
				out.println("good");
				out.println("expt: ");
				String expt = in.readLine();
				File dirE = new File(dir,expt);
				if(!dirE.exists()) {
					if(dirE.mkdir())
						out.println("good");
					else
						out.println("error - cannot make directory "+dirE.getName());
				} else {
					out.println("good");
				}

				//receive files
				String cmd = "";
				File f;
				while(!((cmd = in.readLine()).equals("bye"))) {
					f = new File(dirE,cmd);
					if(f.exists()) {
						out.println(-1);
						continue;
					}
					//find a port for data transmission
					int port = dPort;
					//ServerSocket data = null;
					ServerSocketChannel data = ServerSocketChannel.open();
					while(true) {

						try {
							//data = new ServerSocket(port);
							data.socket().bind(null);
							port = data.socket().getLocalPort();
							break;
						} catch(IOException ioe) {
							port++;
						}
					}
					//dataPorts.addElement(new Integer(port));
					out.println(port);
					//receive file...
					data.socket().setSoTimeout(2000);
					//Socket dataIn = data.accept();
					SocketChannel sc = data.accept();
					try {
						FileOutputStream fos = new FileOutputStream(f);
						//int bIn;
						//System.out.println("pre-ready "+System.currentTimeMillis());
						/*while((bIn=dataIn.getInputStream().read()) != -1) {
							fos.write(bIn);
						}*/
						/*String l;
						while(!(l=in.readLine()).equals("ready")) {
							System.out.println(l);
						}*/
						/*while(dataIn.getInputStream().available() == 0) {} //wait until client starts sending
						System.out.println(System.currentTimeMillis());
						//ByteArrayOutputStream baos = new ByteArrayOutputStream();
						int a = 0; byte[] bIn;
						while(socket.getInputStream().available() == 0) { //apparently there are some gaps... client will send "done" when done
							while((a=dataIn.getInputStream().available()) > 0) {
								bIn = new byte[a];
								dataIn.getInputStream().read(bIn);
								//baos.write(bIn);
								fos.write(bIn);
							}
						}*/
						/*int size = new Integer(in.readLine()).intValue();
						//System.out.println(size);
						FileChannel fc = fos.getChannel();

						fc.transferFrom(sc,0,size);
						//System.out.println(System.currentTimeMillis());

						if(!in.readLine().equals("done"))
							throw new IOException();
						//fos.write(baos.toByteArray());
						//baos.close(); baos = null;
						fos.flush();
						//System.out.println(System.currentTimeMillis());
						fos.close();
						//dataIn.close();
						data.close();
					} catch (IOException ioe) {
						ioe.printStackTrace();
					}
					while(!((cmd = in.readLine()).equals("EOF"))) {}
				}

				//send directory structure, only 1 level in
				String[] d1 = dir.list(); File dir2;
				for(int i = 0; i < d1.length; i++) {
					String contents = d1[i]+":";
					dir2 = new File(dir, d1[i]);
					String[] d2 = dir2.list();
					for(int j = 0; j < d2.length; j++) {
						contents += d2[j]+"\t";
					}
					out.println(contents);
				}
				
				b=false;
			}

			out.close();
			in.close();
			socket.close();

		} catch (IOException e) {
			e.printStackTrace();
		}
    }*/
}