<%@ page import="FACS.UserTools, java.io.*, java.beans.XMLEncoder" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(UserTools.isSampleExperiment(request.getParameter("dir"))) //so we can duplicate sample experiments
	perm = UserTools.MAX_PERM;

if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>

<% String dir = request.getParameter("dir");
	if(request.getParameter("name") == null && request.getParameter("auto") == null) { %>
	<html><head><title>Duplicate Experiment <%= dir %></title></head>
	<body>
	<h1>Duplicate Experiment: <%= dir %></h1>
	<a href="expt.jsp?dir=<%= dir %>">Back</a><p>
	<form action="" method=post>
	Copy Name: <input type=text name="name"><br>
	<input type=submit value="Duplicate">
	</form>
	</body>
	</html>
<%	return;
} %>

<%
boolean auto = false;
if(request.getParameter("auto") != null) {
	auto = Boolean.valueOf(request.getParameter("auto"));
}

String name;
if(!auto) {
	name = request.getParameter("name");
} else {
	name = new File(ROOT,dir).getName();
}

File ndir = new File(new File(ROOT,curUser), name);
File odir = new File(ROOT,dir);
if(!ndir.exists()) {
	if(!ndir.mkdir()) {
		out.println(printError(dir,"Error","Error: Cannot make directory "+ndir.getName()));
		return;
	}

	boolean isLink = false;

	String[] files = odir.list();
	for(int i = 0; i < files.length; i++) {
		if(!files[i].endsWith(".xml"))
			continue;
		if(files[i].equals("link.xml"))
			isLink = true;
		try {
			BufferedInputStream bis = new BufferedInputStream(new FileInputStream(new File(odir,files[i])));
			BufferedOutputStream bos = new BufferedOutputStream(new FileOutputStream(new File(ndir,files[i])));
			byte[] buf = new byte[65536];
			int len = 0;
			while(bis.available() > 0) {
				len = bis.read(buf);
				bos.write(buf,0,len);
			}
			bis.close();
			bos.close();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
	}

	if(!isLink) {
		File link = new File(ndir,"link.xml");
		FileOutputStream fos = new FileOutputStream(link);
		XMLEncoder xenc = new XMLEncoder(fos);
		xenc.setExceptionListener(new java.beans.ExceptionListener() {
				public void exceptionThrown(Exception exception) {
					exception.printStackTrace();
				}
			});
		xenc.writeObject(dir);
		xenc.close();
		fos.close();
	}

	//out.println(printError(dir,"Complete","Duplication Complete."));
	//Print a message then send them to the new experiment
	//			[it actually reloads, but that has the same effect, since we redirect if dir already is copied]
	%>
	<html>
	<head>
	<META HTTP-EQUIV=REFRESH CONTENT=1>
	<title>Duplication Complete</title>
	</head>
	<body>
	<h1>Duplication Complete.</h1>
	Automatically redirecting to <a href="expt.jsp?dir=<%= curUser+"/"+name %>">duplicate</a>.
	</body>
	</html>
	<%
} else {
	if(!auto) {
		out.println(printError(dir,"Error","Error: Directory Already Exists"));
	} else { //if it's auto (i.e. from a sample experiment), then it just means they already made a copy in their directory
		response.sendRedirect("expt.jsp?dir="+curUser+"/"+name);
	}
	return;
} %>

<%!
public String printError(String dir, String title, String msg) {
	StringBuffer b = new StringBuffer();
	b.append("<html><head><title>"+title+"</title></head>");
	b.append("<body>");
	b.append("<h1>"+msg+"</h1>");
	b.append("<a href=\"expt.jsp?dir="+dir+"\">Back</a><p>");
	b.append("</body>");
	b.append("</html>");
	return b.toString();
}
%>