<%@ page import="java.util.*, FACS.Annotator.Plate, FACS.Population, FACS.XMLFiles, FACS.PopStats, java.util.regex.Pattern" %>
<%!
public String printAnnos(Hashtable annos, String file, String[] sel) {
	StringBuffer b = new StringBuffer();
	Hashtable a = (Hashtable)annos.get(file);
	for(int i = 0; i < sel.length; i++) {
		b.append((String)a.get(sel[i])+"\t");
	}
	return b.toString();
}

public boolean arrayContains(String[] array, String element) {
	for(int i = 0; i < array.length; i++) {
		if(array[i].equals(element))
			return true;
	}
	return false;
}

public boolean valueMatches(Collection values, String filter) {
	Pattern p = Pattern.compile(filter,Pattern.CASE_INSENSITIVE);
	for(Iterator i = values.iterator(); i.hasNext();) {
		String value = (String)i.next();
		if(p.matcher(value).find())
			return true;
	}
	return false;
}
%>
<% 
String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}
String dir = request.getParameter("dir");

Vector plates = XMLFiles.getPlates(ROOT,dir);
Hashtable annosBig = XMLFiles.getAnnotations(ROOT,dir);
Vector stats = XMLFiles.readPopStats(ROOT,dir);
if(stats == null) { %>
	<h3>Experiment Populations Not Defined.</h3>
	<i>Please define your populations and gate by clicking <a href="Populations.jsp?dir=<%= dir %>">here</a>.</i>
<%
return;
}

if(request.getParameter("mode") != null && request.getParameter("mode").equals("export")) {
	//okay, ready to export...
	%>
	<% response.setContentType("text/plain"); %>
<%

	String[] sel_annos = request.getParameterValues("annos");
	String[] sel_channels = request.getParameterValues("channels");
	String[] sel_stats = request.getParameterValues("stats");

	//print table header
	for(int i = 0; i < sel_annos.length; i++) {
		out.print(sel_annos[i]+"\t");
	}
	out.print("Population\t");
	out.print("Statistic\tChannel\tValue\n");

	String filter = request.getParameter("filter");
	
	String[] sel_pops = request.getParameterValues("pops");
	String[] sel_plates = request.getParameterValues("plates");
	for(int i = 0; i < sel_plates.length; i++) { //for each selected plate
		Plate p = XMLFiles.getPlate(plates,sel_plates[i]);
		for(int j = 0; j < p.getData().size(); j++) { //for each file
			String file = (String)p.getData().elementAt(j);
			Hashtable annos = (Hashtable)annosBig.get(file);
			if(!filter.equals("")) {
				if(annos == null || !valueMatches(annos.values(),filter))
					continue;
			}
			for(int k = 0; k < sel_pops.length; k++) { //for each population
				boolean comp = true;
				if(sel_pops[k].endsWith("(No Comp)")) {
					sel_pops[k] = sel_pops[k].substring(0,sel_pops[k].length()-10);
					comp = false;
				}
				PopStats ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],comp);
				if(ps == null)
						ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],!comp);
				if(ps == null)
					continue;

				for(int s = 0; s < sel_stats.length; s++) {
					int len = XMLFiles.getStatLength(stats,sel_stats[s]);
					if(len == 1) {
						out.print(printAnnos(annosBig,file,sel_annos));
						out.print(sel_pops[k]+"\t");
						out.print(sel_stats[s]+"\t\t");
						out.print(XMLFiles.getStat(ps,sel_stats[s],0)+"\n");
					} else if(len > 1) {
						for(int c = 0; c < sel_channels.length; c++) {
							out.print(printAnnos(annosBig,file,sel_annos));
							out.print(sel_pops[k]+"\t");
							int ch = new Integer(sel_channels[c].split(":")[0].substring(1)).intValue()-1;
							out.print(sel_stats[s]+"\t"+sel_channels[c]+"\t");
							out.print(XMLFiles.getStat(ps,sel_stats[s],ch)+"\n");
						}
					} else if (sel_stats[s].equals("Global Gate")) {
						out.print(printAnnos(annosBig,file,sel_annos));
						out.print(sel_pops[k]+"\t");
						out.print("Global Gate\t\t");
						if(ps.getGlobal() == PopStats.TRUE)
							out.print("1\n");
						else
							out.print("0\n");
					}
				}
			}

		}
	}
	out.flush();
%>

<%	return;
} //[what follows is the parameter selection page...]
%>
<% response.setContentType("text/html"); %>
<html>
<head><title>Export Data As List</title>
<script language="JavaScript">
function onSubmitForm() {
	if(document.pressed == "comp") {
		document.myform.action = "Export.jsp?dir=<%= request.getParameter("dir") %>&mode=comp";
	} else {
		document.myform.action = "Export.jsp?dir=<%= request.getParameter("dir") %>&mode=export";
	}
}
</script>
</head>
<body>
<h1>Export Data as a List (Experiment <%= request.getParameter("dir") %>)</h1>
<a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a><p>
<%!
public String printSelect(String name, Vector items) {
	StringBuffer b = new StringBuffer();
	b.append("<select name=\""+name+"\" size=17 multiple>");
	for(int i = 0; i < items.size(); i++) {
		b.append("<Option> "+items.elementAt(i).toString()+"\n");
	}
	b.append("</select>");
	return b.toString();
}
%>
<h3>Select The Following Plates/Populations to <u>Export</u><br>and Annotations/Statistics to <u>Display</u></h3>
<%
TreeSet annosS = new TreeSet();
Enumeration e = annosBig.elements();
Hashtable h = null;
while(e.hasMoreElements()) {
	h = (Hashtable)e.nextElement();
	annosS.addAll(h.keySet());
}
Vector annos = new Vector(annosS);

Vector channels = new Vector();
for(int i = 0; i < annos.size(); i++) {
	if(!annos.contains("P"+(i+1)))
		continue;
	channels.add("P"+(i+1)+":"+h.get("P"+(i+1)));
}

Vector pops;
if(request.getParameter("comp") == null) //remove comp populations
	pops = XMLFiles.getPopulationsComp(ROOT,dir,false);
else
	pops = XMLFiles.getPopulations(ROOT,dir);
		

Vector sstats = XMLFiles.getAllStats(stats);
sstats.add("Global Gate");
%>
<form name="myform" method="post" onSubmit="return onSubmitForm()">
<table border cellspacing=0 width=70% >
<tr>
<td>
<b>Filter by Annotation</b><br>
<input type=text name="filter">
<b>Plates</b><br>
<%= printSelect("plates",plates) %>
</td>
<td>
<b>Populations</b><br>
<input type=checkbox name="comp" onClick="document.pressed=this.value; document.myform.submit()" <%= request.getParameter("comp") == null ? "" : "checked" %>>
Display Comp Populations<br>
<%= printSelect("pops",pops) %>
</td>
<td>
<b>Annotations</b><br>
<%= printSelect("annos",annos) %>
</td>
<td>
<b>Statistics</b><br>
<%= printSelect("stats",sstats) %>
</td>
<td>
<b>Channels</b><br>
<%= printSelect("channels",channels) %>
</td>
</tr>
</table>
<input type=submit value="Export" onClick="document.pressed=this.value" >
</form>
</body>
</html>