<%@ page import="java.util.*, FACS.Annotator.Plate, FACS.Population, FACS.XMLFiles, FACS.PopStats, java.awt.Color, java.util.regex.Pattern" %>
<%!
float MIN_HUE, MAX_HUE;

public String delQuad(String region) {
	if(region.endsWith("-UL"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("-UR"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("BL"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("BR"))
		return region.substring(0,region.length()-3);
	return region;
}

public String printAnnos(Hashtable annos, String file, String[] sel) {
	StringBuffer b = new StringBuffer();
	Hashtable a = (Hashtable)annos.get(file);
	for(int i = 0; i < sel.length; i++) {
		b.append("<td>"+(String)a.get(sel[i])+"</td>");
	}
	return b.toString();
}

public boolean arrayContains(String[] array, String element) {
	for(int i = 0; i < array.length; i++) {
		if(array[i].equals(element))
			return true;
	}
	return false;
}

public boolean valueMatches(Collection values, String filter) {
	Pattern p = Pattern.compile(filter,Pattern.CASE_INSENSITIVE);
	for(Iterator i = values.iterator(); i.hasNext();) {
		String value = (String)i.next();
		if(p.matcher(value).find())
			return true;
	}
	return false;
}

public String round(double in, int dec) {
	in *= Math.pow(10,dec);
	double out = (Math.rint(in))/Math.pow(10,dec);
	return new Double(out).toString();
}

public Color getColor(float val, float mean, float max) {
	float light = Math.abs(val-mean);
	light /= (max-mean);
	light = Math.max(Math.min(light,1f),0f);
	float hue = ((val-mean) < 0) ? MIN_HUE : MAX_HUE;
	return Color.getHSBColor(hue, 1f, light);
}

public String getTableCell(float value, float mean, float max, String dir, String file, int ch, String gates) {
	Color color = getColor(value,mean,max);
	String str = Integer.toHexString( color.getRGB() & 0xFFFFFF );
	str = "#" + "000000".substring( str.length() ) + str.toUpperCase();
	return ("<td bgcolor=\""+str+"\"><p align=right><font size=2><b>"
		+"<a href=\"javascript:openWindow('PlotApplet.jsp?dir="
		+dir+"&file="+file
		+"&param1="+ch+"&param2=-1&mode=2&gates='+URLEncode('"+gates+"'))\">"
		+round((double)value,2)
		+"</a></b></font></p></td>");
}
%>
<% 
String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}
String dir = request.getParameter("dir");

MAX_HUE = 0f;
if(request.getParameter("max_hue") != null) {
	try {
		MAX_HUE = new Float(request.getParameter("max_hue")).floatValue() / 255f;
	} catch (NumberFormatException nfe) {
		MAX_HUE = 0f;
	}
}
MIN_HUE = 1f/3f;
if(request.getParameter("min_hue") != null) {
	try {
		MIN_HUE = new Float(request.getParameter("min_hue")).floatValue() / 255f;
	} catch (NumberFormatException nfe) {
		MIN_HUE = 1f/3f;
	}
}

Vector plates = XMLFiles.getPlates(ROOT,dir);
Hashtable annosBig = XMLFiles.getAnnotations(ROOT,dir);
Vector stats = XMLFiles.readPopStats(ROOT,dir);
if(stats == null) { %>
	<h3>Experiment Populations Not Defined.</h3>
	<i>Please define your populations and gate by clicking <a href="Populations.jsp?dir=<%= dir %>">here</a>.</i>
<%
return;
}

Vector pops;
if(request.getParameter("comp") == null) //remove comp populations
	pops = XMLFiles.getPopulationsComp(ROOT,dir,false);
else
	pops = XMLFiles.getPopulations(ROOT,dir);

if(request.getParameter("mode") != null && request.getParameter("mode").equals("export")) {
	//okay, ready to export...
%>
<html><head><title>HeatList</title>
<script language="javascript">
function openWindow(URL) {
	window.open(URL,"mywindow","menubar=1,resizable=1,width=400,height=450");
}
function isEnter(event) {
	if (event && event.keyCode == 13)
		myform.submit();
	else
		return true;
}
function URLEncode(string) {
	var regex = /\+/g;
	string = String(string).replace(regex,"%2B");
	regex = / /g;
	string = String(string).replace(regex,"+");
	return string;
}
</script>
</head>
<body link="#C0C0C0" vlink="#C0C0C0">
<h3 align=center>Heat List Results</h3>
<table width=30%>
<tr><td><a href="expt.jsp?dir=<%= dir %>">Back</a></td>
<td><a href="javascript: document.arrayform.submit()">Cluster</a></td></tr>
</table>

<form name="myform" action="" method="post">
<% for(Enumeration e = request.getParameterNames(); e.hasMoreElements(); ) {
	String name = (String)e.nextElement();
	if(name.equals("min_hue") || name.equals("max_hue"))
			continue;
	String[] vals = request.getParameterValues(name);
	for(int j = 0; j < vals.length; j++) {
	%>
	<input type=hidden name="<%= name %>" value="<%= vals[j] %>">
<%	}
} %>
<table cellspacing=0 align="center">
<tr>
<td><font face="sans-serif" size=2><i>Hues</i></font></td>
<td><input type=text name="min_hue" size=5 value=<%= round((double)MIN_HUE*255,0) %> onkeypress="return isEnter(event)"></td>
<%
Color color; String str;
int n = 20;
float d = 1f/(float)n; //recall that mm[1] is the max-min (i.e. max displacement)
for(int i = -n; i <= n; i++) {
	color = getColor(d*i,0,1);
	str = Integer.toHexString( color.getRGB() & 0xFFFFFF );
	str = "#" + "000000".substring( str.length() ) + str.toUpperCase();
	%>
	<td width=1 bgcolor="<%= str %>">&nbsp;</td>
	<%
}
%>
<td><input type=text name="max_hue" size=5 value=<%= round((double)MAX_HUE*255,0) %> onkeypress="return isEnter(event)"></td>
</tr>
</table>
</form>

<form name="arrayform" action="cluster.jsp?dir=<%= request.getParameter("dir") %>" method="post">
<%
	String[] sel_annos = request.getParameterValues("annos");
	String[] sel_channels = request.getParameterValues("channels");
	String[] sel_stats = request.getParameterValues("stats");

	String filter = request.getParameter("filter");

	//print table header
	out.println("<table cellspacing=0><tr>");
	for(int i = 0; i < sel_annos.length; i++) {
		out.println("<td>"+sel_annos[i]+"</td>");
	}
	out.print("<td>"+"Population</td>");
	int s_len2 = 0;
	if(arrayContains(sel_stats,"Global Gate")) {
		out.print("<td>"+"Global Gate</td>");
	}
	for(int j = 0; j < sel_stats.length; j++) {
		int len = XMLFiles.getStatLength(stats,sel_stats[j]);
		if(len == 1) {
			out.print("<td>"+sel_stats[j]+"</td>");
			out.print("<input type=hidden name=\"x_"+(s_len2)+"\" value=\""+sel_stats[j]+"\">");
			s_len2++;
		} else if(len > 1) {
			for(int i = 0; i < sel_channels.length; i++) {
				out.print("<td><p align=center>"+sel_stats[j]+"<br>"+sel_channels[i]+"</p></td>");
				out.print("<input type=hidden name=\"x_"+(s_len2)+"\" value=\""+sel_stats[j]+":"+sel_channels[i]+"\">");
				s_len2++;
			}
		}
	}
	out.print("</tr>");
	
	String[] sel_pops = request.getParameterValues("pops");
	String[] sel_plates = request.getParameterValues("plates");

	//set up array of statistics, etc. for printing table
	int s_len1 = 0;
	for(int i = 0; i < sel_plates.length; i++) {
		Plate p = XMLFiles.getPlate(plates,sel_plates[i]);
		for(int j = 0; j < p.getData().size(); j++) { //for each file
			String file = (String)p.getData().elementAt(j);
			Hashtable annos = (Hashtable)annosBig.get(file);
			if(!filter.equals("")) {
				if(annos == null || !valueMatches(annos.values(),filter))
					continue;
			}
			for(int k = 0; k < sel_pops.length; k++) { //for each population (= 1 line of output)
				boolean comp = true;
				if(sel_pops[k].endsWith("(No Comp)")) {
					sel_pops[k] = sel_pops[k].substring(0,sel_pops[k].length()-10);
					comp = false;
				}
				/* //problem with these checks here is that they mess up the array size (s_len1)
				PopStats ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],comp);
				if(ps == null)
					ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],!comp);
				if(ps == null)
					continue;*/
				s_len1++;
			}
		}
	}
	double[][] points = new double[s_len1][s_len2];
	%>
	<input type=hidden name="i" value="<%= s_len1 %>">
	<input type=hidden name="j" value="<%= s_len2 %>">
	<%
	double[][] mm = new double[s_len2][2]; //for each _parameter_, mean and max(abs)
	int[] channels = new int[s_len2];
	String[] files = new String[s_len1];

	Hashtable gates = new Hashtable();
	
	for(int i = 0; i < s_len2; i++) { //set mean/max to zero
		mm[i][0] = 0;
		mm[i][1] = 0;
	}
	
	int s_len1_actual = 0;

	int si = 0;
	for(int i = 0; i < sel_plates.length; i++) { //for each selected plate
		Plate p = XMLFiles.getPlate(plates,sel_plates[i]);
		for(int j = 0; j < p.getData().size(); j++) { //for each file
			String file = (String)p.getData().elementAt(j);
			Hashtable annos = (Hashtable)annosBig.get(file);
			if(!filter.equals("")) {
				if(annos == null || !valueMatches(annos.values(),filter))
					continue;
			}
			files[si] = file;
			for(int k = 0; k < sel_pops.length; k++) { //for each population (= 1 line of output)
				boolean comp = true;
				if(sel_pops[k].endsWith("(No Comp)")) { //fix pop name
					sel_pops[k] = sel_pops[k].substring(0,sel_pops[k].length()-10);
					comp = false;
				}
				if(!gates.containsKey(sel_pops[k])) { //add gates to global vector
					Population pop = XMLFiles.getPopulation(pops,sel_pops[k]);
					String g = "";
					for(int pi = 0; pi < pop.getGates().size(); pi++) {
						if(pi != 0)
							g += ",";
						String gate = (String)pop.getGates().elementAt(pi);
						gate = delQuad(gate);
						g += gate;
					}
					gates.put(sel_pops[k],g);
				}

				PopStats ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],comp);
				if(ps == null)
					ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],!comp);
				if(ps == null)
					continue;
				s_len1_actual++;

				int sj = 0;
				for(int s = 0; s < sel_stats.length; s++) {
					int len = XMLFiles.getStatLength(stats,sel_stats[s]);
					if(len == 1) {
						points[si][sj] = XMLFiles.getStat(ps,sel_stats[s],0);
						mm[sj][0] += points[si][sj];
						if(Math.abs(points[si][sj]) > mm[sj][1])
							mm[sj][1] = Math.abs(points[si][sj]);
						channels[sj] = -1;
						sj++;
					} else if(len > 1) {
						for(int c = 0; c < sel_channels.length; c++) {
							int ch = new Integer(sel_channels[c].split(":")[0].substring(1)).intValue()-1;
							points[si][sj] = XMLFiles.getStat(ps,sel_stats[s],ch);
							channels[sj] = ch;
							mm[sj][0] += points[si][sj];
							if(Math.abs(points[si][sj]) > mm[sj][1])
								mm[sj][1] = Math.abs(points[si][sj]);
							sj++;
						}
					}
				}
				si++;
			}
		}
	}

	for(int i = 0; i < s_len2; i++) { //convert sum to mean
		mm[i][0] /= s_len1_actual;
	}
%>
<%
	
	for(si = 0; si < files.length; si++) { //for each selected plate
		String file = files[si];
		for(int k = 0; k < sel_pops.length; k++) { //for each population (= 1 line of output)
			boolean comp = XMLFiles.isComp(ROOT,dir);
			if(sel_pops[k].endsWith("(No Comp)")) {
				sel_pops[k] = sel_pops[k].substring(0,sel_pops[k].length()-10);
				comp = false;
			}
			PopStats ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],comp);
			if(ps == null)
				continue;
			out.println("<tr>");
			out.print(printAnnos(annosBig,file,sel_annos));
			out.print("<td><p align=center>"+sel_pops[k]+"</p></td>");
			out.print("<input type=hidden name=\"y_"+(si+k+si*k)+"\" value=\""+file+":"+sel_pops[k]+"\">");
			if(arrayContains(sel_stats,"Global Gate")) {
				if(ps.getGlobal() == PopStats.TRUE)
					out.print("<td>TRUE</td>");
				else
					out.print("<td>FALSE</td>");
			}

			for(int s = 0; s < s_len2; s++) {
				out.println(getTableCell((float)points[si][s], (float)mm[s][0], (float)mm[s][1], dir, file, channels[s], (String)gates.get(sel_pops[k])));
				//out.println("<td><p align=right>"+round(points[si][s],2)+"</p></td>");
				out.println("<input type=hidden name=\""+si+","+s+"\" value="+points[si][s]+">");
			}
			out.print("</tr>");
		}
	}
%>
</table>
</form>
</body></html>
<%	return;
} //[what follows is the parameter selection page...]
%>

<html>
<head><title>HeatMap as a List</title>
<script language="JavaScript">
function onSubmitForm() {
	if(document.pressed == "comp") {
		document.myform.action = "HeatList.jsp?dir=<%= request.getParameter("dir") %>&mode=comp";
	} else {
		document.myform.action = "HeatList.jsp?dir=<%= request.getParameter("dir") %>&mode=export";
	}
}
</script>
</head>
<body>
<h1>HeatMap as a List (Experiment <%= request.getParameter("dir") %>)</h1>
<a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a><p>
<%!
public String printSelect(String name, Vector items) {
	StringBuffer b = new StringBuffer();
	b.append("<select name=\""+name+"\" size=17 multiple>");
	for(int i = 0; i < items.size(); i++) {
		b.append("<Option> "+items.elementAt(i).toString()+"\n");
	}
	b.append("</select>");
	return b.toString();
}
%>
<h3>Select The Following Plates/Populations to <u>Export</u><br>and Annotations/Statistics to <u>Display</u></h3>
<%
HashSet annosS = new HashSet();
Enumeration e = annosBig.elements();
Hashtable h = null;
while(e.hasMoreElements()) {
	h = (Hashtable)e.nextElement();
	annosS.addAll(h.keySet());
}
Vector annos = new Vector(annosS);

Vector channels = new Vector();
for(int i = 0; i < annos.size(); i++) {
	if(!annos.contains("P"+(i+1)))
		continue;
	channels.add("P"+(i+1)+":"+XMLFiles.htmlEncode((String)h.get("P"+(i+1))));
}

Vector sstats = XMLFiles.getAllStats(stats);
sstats.add("Global Gate");
%>
<form name="myform" method="post" onSubmit="return onSubmitForm()">
<table border cellspacing=0 width=70% >
<tr>
<td>
<b>Filter by Annotation</b><br>
<input type=text name="filter">
<b>Plates</b><br>
<%= printSelect("plates",plates) %>
</td>
<td>
<b>Populations</b><br>
<input type=checkbox name="comp" onClick="document.pressed=this.value; document.myform.submit()" <%= request.getParameter("comp") == null ? "" : "checked" %>>
Display Comp Populations<br>
<%= printSelect("pops",pops) %>
</td>
<td>
<b>Annotations</b><br>
<%= printSelect("annos",annos) %>
</td>
<td>
<b>Statistics</b><br>
<%= printSelect("stats",sstats) %>
</td>
<td>
<b>Channels</b><br>
<%= printSelect("channels",channels) %>
</td>
</tr>
</table>
<input type=submit value="Generate" onClick="document.pressed=this.value" >
</form>
</body>
</html>