<%@ page import="java.util.*, FACS.Annotator.Plate, FACS.Population, FACS.XMLFiles, FACS.PopStats, java.awt.Color, java.util.regex.Pattern, java.awt.Font, java.awt.font.FontRenderContext, java.awt.geom.Rectangle2D" %>

<% 
String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}
String dir = request.getParameter("dir");

//load all of the things we need...
Vector plates = XMLFiles.getPlates(ROOT,dir);
Hashtable annosBig = XMLFiles.getAnnotations(ROOT,dir);
Vector stats = XMLFiles.readPopStats(ROOT,dir);
Vector pops = XMLFiles.getPopulationsComp(ROOT,dir,false);
Vector sstats = XMLFiles.getAllStats(stats);
//get annotations and channels
HashSet annosS = new HashSet();
Hashtable h = null;
for(Enumeration e = annosBig.elements(); e.hasMoreElements(); ) {
	h = (Hashtable)e.nextElement();
	annosS.addAll(h.keySet());
}
Vector annos = new Vector(annosS);

Vector channels = new Vector();
for(int i = 0; i < annos.size(); i++) {
	if(!annos.contains("P"+(i+1)))
		continue;
	channels.add("P"+(i+1)+":"+h.get("P"+(i+1)));
}


%>
<html><head><title>MetaAnalysis</title></head>
<body>
<h2>MetaAnalysis - <%= dir %></h2>
<a href="expt.jsp?dir=<%= dir %>">Back</a><br>

<form action="" method="post">
<h3>Source Data</h3>
<table width=100% border>
<%
int num = 0;
if(request.getParameter("num") != null) {
	num = new Integer(request.getParameter("num")).intValue();
}
if(request.getParameter("plates_"+(num-1)) != null && (!request.getParameter("plates_"+(num-1)).equals("") || !request.getParameter("pops_"+(num-1)).equals("") || !request.getParameter("anno_"+(num-1)).equals(""))) {
	num++;
}
if(num == 0)
	num++;
%>
<tr>
<% for(int i = 0; i < num; i++) { %>
	<td>Data #<%= i+1 %> Label <input type=text name="name_<%= i %>" value="<%= request.getParameter("name_"+i) != null ? request.getParameter("name_"+i) : "" %>">
	</td>
<% } %>
</tr>
<tr>
<% for(int i = 0; i < num; i++) { %>
	<td>
	<table>
	<tr><td><b>Plates<b><br><%= printSelect("plates_"+i,5,plates,request.getParameterValues("plates_"+i)) %></td>
	<td><b>Populations<b><br><%= printSelect("pops_"+i,5,pops,request.getParameterValues("pops_"+i)) %><br></td></tr>
	</table>
	<b>Annotation Filter </b><input type=text name="anno_<%= i %>" value="<%= request.getParameter("anno_"+i) != null ? request.getParameter("anno_"+i) : "" %>"><br>
	<b>Statistic </b><%= printSelect("stat_"+i,0,sstats, new String[]{request.getParameter("stat_"+i)}) %><br>
	<b>Channel </b><%= printSelect("chan_"+i,0,channels, new String[]{request.getParameter("chan_"+i)}) %>
	</td>
<% } %>
</tr>
</table>
<input type=hidden name="num" value="<%= num %>">
<p>
<b>Plot Output Parameters</b><br>
<%!
static Vector plots;
final int BAR = 0;
final int HIST = 1;
final int LINE = 2;
final int SCATTER = 3;
%>
<%
if(plots == null) {
	plots = new Vector();
	plots.add("Bar");
	plots.add("Histogram");
	plots.add("Line");
	plots.add("Scatter");
}
%>
Plot Type <%= printSelect("plot",0,plots,new String[]{request.getParameter("plot") != null ? request.getParameter("plot") : "Bar" }) %><br>
Annotation (Data Bin / X-Axis) <%= printSelect("anno",0,annos,new String[]{request.getParameter("anno") != null ? request.getParameter("anno") : "filename" }) %><br>
Force: y-min <input type=text name="y-min" value="<%= request.getParameter("y-min") != null ? request.getParameter("y-min") : "" %>">
y-max <input type=text name="y-max" value="<%= request.getParameter("y-max") != null ? request.getParameter("y-max") : "" %>"><br>
Force: x-min <input type=text name="x-min" value="<%= request.getParameter("x-min") != null ? request.getParameter("x-min") : "" %>">
x-max <input type=text name="x-max" value="<%= request.getParameter("x-max") != null ? request.getParameter("x-max") : "" %>"> (XY Plots Only)<br>
Histogram Divisions: <input type=text name="hist_div" value="<%= request.getParameter("hist_div") != null ? request.getParameter("hist_div") : "10%" %>"> <font size=2>(either "13%", for percent of range, or "20", for absolute numbers).</font><br>
Logarithmic Scales (XY Plots Only): <input type=checkbox name="xlog" <%= request.getParameter("xlog") != null ? "checked" : "" %>>X-Axis <input type=checkbox name="ylog" <%= request.getParameter("ylog") != null ? "checked" : "" %>>Y-Axis<br>
<%
Vector datas = new Vector();
datas.add("Annotation");
for(int i = 0; i < num; i++)
	datas.add((request.getParameter("name_"+i) != null && !request.getParameter("name_"+i).equals("")) ? request.getParameter("name_"+i) : "Data #"+i);
%>
Scatterplot: X-Axis <%= printAxisSelect("xaxis",0,datas,new String[]{request.getParameter("xaxis") != null ? (String)datas.elementAt(new Integer(request.getParameter("xaxis")).intValue()) : "" }) %>
Y-Axis <%= printAxisSelect("yaxis",0,datas,new String[]{request.getParameter("yaxis") != null ? (String)datas.elementAt(new Integer(request.getParameter("yaxis")).intValue()) : "" }) %><br>
<input type=submit value="Plot">
</form>

<p>
<% //get all data points into a vector of hashes
String plot = request.getParameter("plot");
int mode;
if(plot == null || plot.equals(plots.elementAt(BAR)))
	mode = BAR;
else if(plot.equals(plots.elementAt(HIST)))
	mode = HIST;
else if(plot.equals(plots.elementAt(LINE)))
	mode = LINE;
else if(plot.equals(plots.elementAt(SCATTER)))
	mode = SCATTER;
else
	mode = BAR;

//collect data values
Vector series = new Vector();
double ymin = Double.NaN, ymax = Double.NaN;
int n_columns = 0;
for(int di = 0; di < num; di++) {
	String[] sel_plates = request.getParameterValues("plates_"+di);
	if(sel_plates == null)
		continue;
	String[] sel_pops = request.getParameterValues("pops_"+di);
	if(sel_pops == null)
		continue;
	String filter = request.getParameter("anno_"+di);
	String stat = request.getParameter("stat_"+di);
	String chan = request.getParameter("chan_"+di);

	Hashtable data = new Hashtable();

	for(int i = 0; i < sel_plates.length; i++) { //for each selected plate
		Plate p = XMLFiles.getPlate(plates,sel_plates[i]);
		for(int j = 0; j < p.getData().size(); j++) { //for each file
			String file = (String)p.getData().elementAt(j);
			Hashtable annosF = (Hashtable)annosBig.get(file);
			if(!filter.equals("")) {
				if(annosF == null || !valueMatches(annosF.values(),filter))
					continue;
			}
			for(int k = 0; k < sel_pops.length; k++) { //for each population (= 1 line of output)
				boolean comp = true;

				PopStats ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],comp);
				if(ps == null)
					ps = XMLFiles.getStatsByFilePop(stats,file,sel_pops[k],!comp);
				if(ps == null)
					continue;

				int ch = new Integer(chan.split(":")[0].substring(1)).intValue()-1;
				double val = XMLFiles.getStat(ps,stat,ch);
				if(Double.isNaN(val))
					continue;

				String key = (String)((Hashtable)annosBig.get(file)).get(request.getParameter("anno"));
				if(key == null)
					key = "";
				if(!data.containsKey(key)) {
					n_columns++;
					if(di == 0)
						n_columns++;
				}
				if(data.containsKey(key))
					val += ((Double)data.get(key)).doubleValue();
				data.put(key,new Double(val));
				if(Double.isNaN(ymin))
					ymin = val;
				if(Double.isNaN(ymax))
					ymax = val;
				if(val < ymin)
					ymin = val;
				if(val > ymax)
					ymax = val;
			}
		}
		if(data.size() > 0)
			series.add(data);
	}
} %>

<%! static Vector colors; %>

<%
if(colors == null) {
	colors = new Vector();
	colors.add("purple");
	colors.add("maroon");
	colors.add("navy");
	colors.add("olive");
	colors.add("lime");
}
%>

<% if(mode == HIST) { //bin data...
	String hist_div = request.getParameter("hist_div");
	double dX;
	if(hist_div.endsWith("%")) {
		hist_div = hist_div.substring(0,hist_div.length()-1);
		dX = new Double(hist_div).doubleValue()/100d;
		dX *= (ymax-ymin);
	} else {
		dX = new Double(hist_div).doubleValue();
	}
	int n = (int)Math.ceil((ymax-ymin)/dX);

	double t_ymax = 0; //, t_ymin = Double.NaN;
	for(int i = 0; i < series.size(); i++) {
		Hashtable data = (Hashtable)series.elementAt(i);
		double[] hist = new double[n+1];
		Arrays.fill(hist,0);
		double val; int index;
		for(Enumeration e = data.keys(); e.hasMoreElements(); ) {
			val = ((Double)data.get(e.nextElement())).doubleValue();
			index = (int)Math.ceil((val-ymin)/dX); //ceil-> # vals <= bin
			if(index < 0)
				index = 0;
			if(index > n)
				index = n;
			hist[index]++;
		}
		data = new Hashtable();
		for(int j = 0; j < hist.length; j++) {
			if(hist[j] > t_ymax)
				t_ymax = hist[j];
			/*if(Double.isNaN(t_ymin))
				t_ymin = hist[j];
			if(hist[j] < t_ymin)
				t_ymin = hist[j];*/
			data.put(round(ymin+j*dX,2),new Double(hist[j]));
		}

		series.setElementAt(data,i);
	}

	ymin = 0; ymax = t_ymax;
}
%>

<%
String minStr = request.getParameter("y-min");
if(minStr != null && !minStr.equals("")) {
	ymin = new Double(minStr).doubleValue();
}
String maxStr = request.getParameter("y-max");
if(maxStr != null && !maxStr.equals("")) {
	ymax = new Double(maxStr).doubleValue();
}

int col_width=5;
%>

<% if(series.size() > 0 && (mode == BAR || mode == HIST)) { //bar plots / histograms %>
	<% Hashtable data = (Hashtable)series.elementAt(0); %>
	<% int width = col_width*(series.size()+1); %>
	<% //calculate Font size (can't do it in SVG)
	float size = 20;
	FontRenderContext frc = new FontRenderContext(null,true,true);
	Font font = new Font("Arial",Font.PLAIN,(int)size);
	Rectangle2D rect = font.getMaxCharBounds(frc);
	while((rect.getHeight() > width || font.getStringBounds((String)data.keys().nextElement(),frc).getWidth() > 200) && size > 10) {
		size--;
		font = font.deriveFont(size);
		rect = font.getMaxCharBounds(frc);
	}
	width = (int)rect.getHeight();
	double max_height = 0; //all labels need to fill the same space

	Vector keys = new Vector();
	for(Enumeration e = data.keys(); e.hasMoreElements(); )
		keys.add(e.nextElement());
	Collections.sort(keys, new PossibleNumberComparator());

	for(Enumeration e = keys.elements(); e.hasMoreElements(); ) {
		String key = (String)e.nextElement();
		if(font.getStringBounds(key,frc).getWidth() > max_height)
			max_height = font.getStringBounds(key,frc).getWidth();
	}
	max_height += 10;
	%>
	<table width=<%= width*2*data.size()+100 %> cellspacing=0 cellpadding=0><tr>
	<td>
	<b>Legend</b><br>
	<% for(int i = 0; i < series.size(); i++) { %>
		<table><tr>
		<td width="30" bgcolor="<%= colors.elementAt(i) %>">&nbsp;</td>
		<td><%= (request.getParameter("name_"+i) != null && !request.getParameter("name_"+i).equals("")) ? request.getParameter("name_"+i) : "Data #"+(i+1) %></td>
		</tr></table>
	<% } %>
	</td>
	<td>
	<TABLE bgColor="silver" height=400 cellspacing=0>
	<tr>
	<td rowspan=2>
	<table height="100%" Align="left" bgcolor="white">
	<tr><td><p align="right"><%= round(ymax,2) %></p></td></tr>
	<tr><td height="100%">&nbsp;</td></tr>
	<tr><td><p align="right"><%= round(ymin,2) %></p></td></tr>
	</table>
	</td>
	<TD VAlign=bottom height=100%>
	<% for(Enumeration e = keys.elements(); e.hasMoreElements(); ) { 
		String bin = (String)e.nextElement(); %>
		<table height=100% cellspacing=0 align="left" width=<%= width %> cellpadding=0><tr height=100%>
		<% for(int i = 0; i < series.size(); i++) {
			Hashtable tdata = (Hashtable)series.elementAt(i);
			if(tdata.containsKey(bin)) {
				double val = ((Double)tdata.get(bin)).doubleValue();
				val = (val-ymin)/(ymax-ymin)*100d; %>
				<td width=<%= col_width %>><TABLE height="100%" width=<%= col_width %> cellspacing=0 cellpadding=0 Align="left">
				<TR><TD></TD></TR>
				<tr><td Height="<%= 100d-val %>%"></td></tr>
				<TR><TD Height="<%= val %>%" bgColor="<%= colors.elementAt(i) %>"></TD></TR>
				</TABLE></td>
		<% }
		} %>
		<td width=<%= col_width %>><TABLE height="100%" width=<%= col_width %> cellspacing=0 Align="left">
		<TR><TD></TD></TR>
		</TABLE></td>
		</tr>
		<tr><td colspan=<%= series.size()+1 %>>
		<embed width=<%= width %> height="<%= max_height %>" src="vertical_text.jsp?text=<%= bin %>&size=<%= size %>" name="printable_text" type="image/svg+xml" pluginspage="http://www.adobe.com/svg/viewer/install/" wmode="transparent">
		</td></tr>
		</table>
	<% }%>
	</TD></tr>
	</TABLE>
	</td>
	</tr></table>
<% } %>
<% if(series.size() != 0 && mode == LINE) {
	long time = System.currentTimeMillis();
	session.setAttribute(""+time,series); %>
	<table>
	<tr>
	<td>
	<b>Legend</b><br>
	<% for(int i = 0; i < series.size(); i++) { %>
		<table><tr>
		<td width="30" bgcolor="<%= colors.elementAt(i) %>">&nbsp;</td>
		<td><%= (request.getParameter("name_"+i) != null && !request.getParameter("name_"+i).equals("")) ? request.getParameter("name_"+i) : "Data #"+(i+1) %></td>
		</tr></table>
	<% } %>
	</td>
	<td>
	<embed width=500 height=400 src="linegraph.jsp?t=<%= time %>&xmin=<%= request.getParameter("x-min") %>&xmax=<%= request.getParameter("x-max") %>&ymin=<%= ymin %>&ymax=<%= ymax %>&xlog=<%= request.getParameter("xlog") %>&ylog=<%= request.getParameter("ylog") %>" name="line_graph" type="image/svg+xml" pluginspage="http://www.adobe.com/svg/viewer/install/">
	</td>
	</tr>
	</table>
<% } %>

<% if(series.size() != 0 && mode == SCATTER) {
	long time = System.currentTimeMillis();
	session.setAttribute(""+time,series); %>
	<table>
	<tr>
	<td>
	<embed width=500 height=400 src="scatterplot.jsp?t=<%= time %>&x-axis=<%= request.getParameter("xaxis") %>&y-axis=<%= request.getParameter("yaxis") %>&xmin=<%= request.getParameter("x-min") %>&xmax=<%= request.getParameter("x-max") %>&ymin=<%= request.getParameter("y-min") %>&ymax=<%= request.getParameter("y-max") %>&xlog=<%= request.getParameter("xlog") %>&ylog=<%= request.getParameter("ylog") %>" name="scatterplot" type="image/svg+xml" pluginspage="http://www.adobe.com/svg/viewer/install/">
	</td>
	</tr>
	</table>
<% } %>

</body>
</html>

<%!
public String printSelect(String name, int size, Vector values, String[] selected) {
	StringBuffer b = new StringBuffer();
	b.append("<SELECT name=\""+name+"\" size="+size+" ");
	if(size != 0)
		b.append("multiple");
	b.append(">\n");
	for(int i = 0; i < values.size(); i++) {
		if(arrayContains(selected,values.elementAt(i).toString()))
			b.append("<Option selected> "+values.elementAt(i).toString()+"\n");
		else
			b.append("<Option> "+values.elementAt(i).toString()+"\n");
	}
	b.append("</select>");
	return b.toString();
}

public String printAxisSelect(String name, int size, Vector values, String[] selected) {
	StringBuffer b = new StringBuffer();
	b.append("<SELECT name=\""+name+"\" size="+size+" ");
	if(size != 0)
		b.append("multiple");
	b.append(">\n");
	for(int i = 0; i < values.size(); i++) {
		if(arrayContains(selected,values.elementAt(i).toString()))
			b.append("<Option value=\""+i+"\" selected> "+values.elementAt(i).toString()+"\n");
		else
			b.append("<Option value=\""+i+"\" > "+values.elementAt(i).toString()+"\n");
	}
	b.append("</select>");
	return b.toString();
}

public boolean arrayContains(String[] array, String value) {
	if(array == null || array[0] == null)
		return false;
	for(int i = 0; i < array.length; i++)
		if(array[i].equals(value))
			return true;
	return false;
}

public boolean valueMatches(Collection values, String filter) {
	Pattern p = Pattern.compile(filter,Pattern.CASE_INSENSITIVE);
	for(Iterator i = values.iterator(); i.hasNext();) {
		String value = (String)i.next();
		if(p.matcher(value).find())
			return true;
	}
	return false;
}

public String round(double in, int dec) {
	in *= Math.pow(10,dec);
	double out = (Math.rint(in))/Math.pow(10,dec);
	return new Double(out).toString();
}

class PossibleNumberComparator implements Comparator, java.io.Serializable {
	public int compare(Object o1, Object o2) {
		String s1 = (String)o1;
		String s2 = (String)o2;

		try {
			double d1 = new Double(s1).doubleValue();
			double d2 = new Double(s2).doubleValue();
			return Double.compare(d1,d2);
		} catch (NumberFormatException nfe) {
			return s1.compareTo(s2);
		}
	}
}
%>