<%@ page import="java.io.*, java.beans.XMLDecoder, java.util.Hashtable, java.util.Vector, FACS.Plot.Region, FACS.Population, FACS.XMLFiles, FACS.UserTools, FACS.Plot.PlotServlet.TimedConcurrentHashMap" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.VIEW_PERM) {
	response.sendRedirect("index.jsp");
	return;
}

%>
<html><head><title>Populations</title></head>
<body>
<h1>Populations - <%= request.getParameter("dir") %></h1>
<table width="40%">
<tr>
<td><a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a></td>
<td width="20%">&nbsp;</td>
<%
Vector files = XMLFiles.getFiles(ROOT,request.getParameter("dir"));
int f = 0;
if(request.getParameter("i") != null)
	f = new Integer(request.getParameter("i")).intValue();
%>
<td><a href="PopPrint.jsp?dir=<%= request.getParameter("dir") %>&i=<%= f %>">Print</a></td>
</tr>
</table><p>
<%
File xml = new File(ROOT+request.getParameter("dir"),"regions.xml");
Hashtable regions = new Hashtable();
try {
	XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
	d.setExceptionListener(new java.beans.ExceptionListener() {
		public void exceptionThrown(Exception exception) {
			exception.printStackTrace();
		}
	});
	double[] vals;
	while(true) {
		try {
			Region r = (Region)d.readObject();
			vals = r.getVals("_global");
			regions.put(r.getName(),vals);
		} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
			d.close();
			break;
		}
	}
} catch (IOException ioe) {
	ioe.printStackTrace();
%>
	<h3>No gating regions defined.</h3>
	<i>Please design gates by clicking <a href="PlotPlate.jsp?dir=<%= request.getParameter("dir") %>">here</a>.</i>
<%
	return;
}
%>
<form method=post action="" name="myform">
<%
out.println("<p>"+printFileSelect(files,f)+"<br>");
%>
</form>
<%
Vector pops = XMLFiles.getPopulationsComp(ROOT,request.getParameter("dir"),false);
for(int i = 0; i < pops.size(); i++) {
	Population p = (Population)pops.elementAt(i);
	Vector g = p.getGates();
	Vector gates = new Vector();
	%>
	<table border>
	<tr><td colspan=<%= g.size() %>><b><em><%= p.getName() %></em></b></td></tr>
	<tr>
	<% for(int j = 0; j < g.size(); j++) { 
		String gate = (String)g.elementAt(j);
		gate = delQuad(gate);
		double[] vals = (double[])regions.get(gate);
		%>
		<td><b><%= gate %></b><br>
		<applet code="FACS.Plot.PlotApplet.PlotApplet.class" archive="PlotApplet.jar" width=350 height=350>
		<param name="directory" value="<%= request.getParameter("dir") %>">
		<param name="file" value="<%= (String)files.elementAt(f) %>">
		<param name="param1" value=<%= (int)vals[1] %>>
		<param name="param2" value=<%= (int)vals[2] %>>
		<param name="mode" value=1>
		<param name="region" value=<%= gate %>>
		<param name="gates" value="<%= join(gates) %>">
		<param name="compact" value="true">
		</applet>
		</td>
	<% gates.add(gate);
		} %>
	</tr>
	</table>
<% } %>
</body></html>

<%!
public String printFileSelect(Vector files, int index) {
	StringBuffer b = new StringBuffer();
	b.append("<Select name=\"i\" onChange=\"document.myform.submit();\">\n");
	for(int i = 0; i < files.size(); i++) {
		String r = (String)files.elementAt(i);
		if(i == index)
			b.append("<Option selected value=\""+i+"\"> "+r+"\n");
		else
			b.append("<Option value=\""+i+"\"> "+r+"\n");
	}
	b.append("</Select>");
	return b.toString();
}

public String delQuad(String region) {
	if(region.endsWith("-UL"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("-UR"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("-BL"))
		return region.substring(0,region.length()-3);
	else if(region.endsWith("-BR"))
		return region.substring(0,region.length()-3);
	return region;
}

public String join(Vector in) {
	StringBuffer b = new StringBuffer();
	for(int i = 0; i < in.size(); i++)
		b.append((String)in.elementAt(i)+",");
	return b.toString();
}
%>