<%@ page import="java.beans.XMLDecoder, java.io.*, java.util.Vector, java.util.Hashtable, FACS.Plot.Region, FACS.Annotator.Plate, FACS.Population, FACS.XMLFiles, FACS.UserTools, java.util.regex.*, java.net.URLEncoder" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>

<html><head><title>Populations</title></head>
<script language="JavaScript" src="PopupWindow.js"></script>
<script language="JavaScript" src="AnchorPosition.js"></script>
<script language="JavaScript">
function onSubmitForm() {
	if(document.pressed == "Add Population") {
		document.myform.action = "";
	} else if (document.pressed == "Gate") {
		document.myform.action = "gate.jsp?dir=<%= request.getParameter("dir") %>&mode=new";
	} else {
		document.myform.action = "";
	}
}

function clearGate(i) {
	document.myform.elements["name_"+i].value="";
	document.myform.elements["cb_"+i].value="";
	var g = 0;
	while(document.myform.elements["g_"+i+"_"+g]) {
		document.myform.elements["g_"+i+"_"+g].value = "";
		g++;
	}
}

//Data file selection window
var popup = new PopupWindow();
popup.offsetY=25;
popup.setSize(500,350);
popup.autoHide();
var popupinput = null;
popup.setUrl("MiniPlate.jsp?dir=<%= request.getParameter("dir") %>");
popup.setWindowProperties("scrollbars=yes");
var cbstring = ""; var obj;
function popupactivate(cb,el,anchor) { //tell it which population & what the old set was
	obj = el;
	cbstring = cb;
	if(cbstring == "null") {
		cbstring = "";
	}
	popup.showPopup(anchor);
}
function setCBString(val) { //get back info from popup (called by child window when it closes)
	obj.value = val;
	cbstring = "";
	//popup.hidePopup();
}
function getCBString() { //called by child window when it opens
	return cbstring;
}

</script>
<body>
<h1 align="center">Define Populations</h1>
<a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a><br>
<%!
public static final int NONE = 0;
public static final int ELLIPSE = 1;
public static final int RECT = 2;
public static final int POLY = 3;
public static final int QUAD = 4;
public static final int RANGE = 5;

/**
 * Returns true if it's a gate drawn for compensation "p{i}N" or "p{i}P" where {i} is an integer
 * @param name
 * @return
 */
public boolean isCompGate(String name) {
	Matcher m = Pattern.compile("p\\d+[PN]").matcher(name);
	if(m.find())
		return true;
	return false;
}

public String getParameter(String name, HttpServletRequest request, Hashtable h) {
	if(h == null)
		return request.getParameter(name);
	else
		return (String)h.get(name);
}

public Hashtable getPops(String ROOT, String dir) {
	Hashtable h = new Hashtable();
	Vector plates = XMLFiles.getPlates(ROOT,dir);
	File xml = new File(ROOT+dir,"pops.xml");
	if(!xml.exists()) {
		return null;
	}
	try {
		XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
		d.setExceptionListener(new java.beans.ExceptionListener() {
			public void exceptionThrown(Exception exception) {
				exception.printStackTrace();
			}
		});
		Vector pops = new Vector();
		int i = 0;
		int pi = 0; //number of pops - compensation ones
		while(true) {
			try {
				Population p = (Population)d.readObject();
				if(p.getName().matches("^p\\d[PN]$") || p.getName().matches("^pN$")) { //don't include compensation populations here...
					//i++;
					continue;
				}
				pi++;
				h.put("name_"+i,p.getName());
				for(int j = 0; j < p.getGates().size(); j++) {
					h.put("g_"+i+"_"+j,(String)p.getGates().elementAt(j));
				}
				
				String cbstring = "";
				for(int j = 0; j < plates.size(); j++) {
					Plate plate = (Plate)plates.elementAt(j);
					cbstring += XMLFiles.htmlEncode(plate.getFullName())+":"; //urlEncode(plate.getFullName())+":";
					cbstring += getWells(plate,p.getFiles());
					cbstring += ";";
				}
				h.put("cb_"+i,cbstring);
				i++;
			} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
				d.close();
				break;
			}
		}
		h.put("nPops",(pi)+"");
	} catch(FileNotFoundException fnfe) {
		return null;
	}
	return h;
}

public String urlEncode(String s) {
	try {
		return URLEncoder.encode(s,"UTF-8").replaceAll("\\+","\\%20");
	} catch(UnsupportedEncodingException uee) {
		return s;
	}
}

public String getWells(Plate p, Vector files) {
	String wells = "";
	for(int i = 0; i < files.size(); i++) {
		String file = (String)files.elementAt(i);
		int n = p.getData().indexOf(file);
		if(n == -1)
			continue;
		int[] rc = p.getRC(n);
		wells += getLetter(rc[0])+(rc[1]+1)+",";
	}
	return wells;
}

public String getLetter(int index) {
	if(index == 0)
		return "A";
	int a = (int)new Character('A').charValue();
	char[] c = { (char)(a+index) };
	return new String(c);
}

public String getParam(double[] gate, int num) {
	if((int)gate[0] != RANGE)
		return "P"+((int)gate[num]+1);
	
	double theta = Math.atan((gate[6]-gate[4])/(gate[5]-gate[3]));
	if((theta < Math.PI/5 && theta > -Math.PI/5) || gate[2] == -1) {
		if(num == 1)
			return "P"+((int)gate[1]+1);
		else
			return "";
	} else {
		if(num == 1)
			return "P"+((int)gate[2]+1);
		else
			return "";
	}
}

public String getType(int i) {
	i = Math.abs(i);
	if(i == RECT)
		return "Rectangle";
	if(i == ELLIPSE)
		return "Ellipse";
	if(i == QUAD)
		return "Quadrants";
	if(i == POLY)
		return "Polygon";
	if(i == RANGE)
		return "Range";
	return "error";
}

public String printGateList(Vector regions, int n1, int n2, String sel) {
	StringBuffer b = new StringBuffer();
	b.append("<Select name=\"g_"+n1+"_"+n2+"\" onChange=\"document.pressed='Add Population'; document.myform.submit();\">\n");
	b.append("<Option>\n");
	for(int i = 0; i < regions.size(); i++) {
		String r = (String)regions.elementAt(i);
		if(r.equals(sel))
			b.append("<Option selected> "+r+"\n");
		else
			b.append("<Option> "+r+"\n");
	}
	b.append("</Select>");
	return b.toString();
}

public String printFileSelect(Vector files, int index) {
	StringBuffer b = new StringBuffer();
	b.append("<Select name=\"i\" onChange=\"document.pressed='Add Population'; document.myform.submit();\">\n");
	for(int i = 0; i < files.size(); i++) {
		String r = (String)files.elementAt(i);
		if(i == index)
			b.append("<Option selected value=\""+i+"\"> "+r+"\n");
		else
			b.append("<Option value=\""+i+"\"> "+r+"\n");
	}
	b.append("</Select>");
	return b.toString();
}
%>

<%--set up regions--%>
<%
String dir = request.getParameter("dir");
%>
<h3>(Experiment <%= dir %>)</h3>
<%
File xml = new File(ROOT+dir,"regions.xml");
if(!xml.exists()) {
%>
	<h3>No gating regions defined.</h3>
	<i>Please design gates by clicking <a href="PlotPlate.jsp?dir=<%= dir %>">here</a>.</i>
<%
return;
}
%>
<form name="myform" method="post" onSubmit="return onSubmitForm()">
<table width=70%>
<tr><td>
<%
Vector regions;
Hashtable rParams;
try {
	XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
	d.setExceptionListener(new java.beans.ExceptionListener() {
		public void exceptionThrown(Exception exception) {
			exception.printStackTrace();
		}
	});
	regions = new Vector();
	rParams = new Hashtable();
	%>
	<i>Regions defined:</i><br>
	<SELECT name="region" size=10 onClick="myform.submit()">
	<%
	double[] vals;
	while(true) {
		try {
			Region r = (Region)d.readObject();
			if(isCompGate(r.getName()))
				continue;
			vals = r.getVals("_global");
			%>
			<Option <%= (request.getParameter("region") != null && request.getParameter("region").equals(r.getName())) ? "selected" : "" %> value="<%= r.getName() %>">
			<%= r.getName() %> (<%= getType((int)vals[0]) %>: <%= getParam(vals,1) %> x <%= getParam(vals,2) %>)
			<%
			rParams.put(r.getName(),(int)vals[1]+","+(int)vals[2]);

			if((int)vals[0] == QUAD) {
				regions.add(r.getName()+"-UL");
				regions.add(r.getName()+"-UR");
				regions.add(r.getName()+"-BL");
				regions.add(r.getName()+"-BR");
			} else {
				regions.add(r.getName());
			}
		} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
			d.close();
			break;
		}
	}
	out.println("</SELECT>");
} catch (IOException ioe) {
	ioe.printStackTrace();
%>
	<h3>No gating regions defined.</h3>
	<i>Please design gates by clicking <a href="PlotPlate.jsp?dir=<%= dir %>">here</a>.</i>
<%
	return;
}
%>
</td>
<td width=30% >
<%--display a plot, with drop-down for file selection--%>
<%
Vector files = XMLFiles.getFiles(ROOT,dir);
int f = 0;
if(request.getParameter("i") != null)
	f = new Integer(request.getParameter("i")).intValue();
out.println("<p align=center>"+printFileSelect(files,f)+"<br>");
%>
<applet code="FACS.Plot.PlotApplet.PlotApplet.class" archive="PlotApplet.jar" width=360 height=360>
<param name="directory" value="<%= dir %>">
<param name="file" value="<%= (String)files.elementAt(f) %>">
<% if(request.getParameter("region") == null) { %>
<param name="param1" value=-1>
<param name="param2" value=-1>
<% } else { %>
<param name="param1" value=<%= ((String)rParams.get(request.getParameter("region"))).split(",")[0] %>>
<param name="param2" value=<%= ((String)rParams.get(request.getParameter("region"))).split(",")[1] %>>
<% } %>
<param name="mode" value=1>
<param name="compact" value="true">
</applet>
</p>
</td>
</tr>
</table>
<hr>

<%--set up populations input--%>
<%
Hashtable h = null;
if(request.getParameter("nPops") == null) //so we don't overwrite the parameters if we already were here
	h = getPops(ROOT, dir); //load old populations from pops.xml
int nPops = 1;
if(getParameter("nPops",request,h) != null)
	nPops = new Integer(getParameter("nPops",request,h)).intValue();
if(getParameter("name_"+(nPops-1),request,h) != null && !getParameter("name_"+(nPops-1),request,h).equals(""))
	nPops++;
if(nPops == 0)
	nPops++;
out.println("<ul>");
boolean dup = false;
for(int i = 0; i < nPops; i++) {
	String name = "";
	if(getParameter("name_"+i,request,h) != null)
		name = getParameter("name_"+i,request,h);
%>
	<li><b>Population<input type=submit name="dup_<%= i %>" style="font-size:10;" value="Duplicate" onClick="document.pressed=this.value">
	<input type=button name="clear_<%= i %>" style="font-size:10" value="Clear" onClick="clearGate(<%= i %>); document.pressed=this.value">
	: <input type=text name="name_<%= i %>" value="<%= name %>">
<%
	int j = 0;
	while(getParameter("g_"+i+"_"+j,request,h) != null && !getParameter("g_"+i+"_"+j,request,h).trim().equals("")) {
		out.println(" Gate "+(j+1)+":"+printGateList(regions,i,j,getParameter("g_"+i+"_"+j,request,h)));
		j++;
	}
	out.println(" Gate "+(j+1)+":"+printGateList(regions,i,j,""));
%>
	<input type=hidden name="cb_<%= i %>" value='<%= getParameter("cb_"+i,request,h) %>'>
	<A href="#" onClick="popupactivate(document.myform.cb_<%= i %>.value,document.myform.cb_<%= i %>,'anchor1'); return false" NAME="anchor1" ID="anchor1">Select Files to Gate</A>
	</b></li>
<%
	if(getParameter("dup_"+i,request,h) != null) {
		nPops--;
		dup = true;
		name = name+" copy";
	%>
		<li><b>Population<input type=submit name="dup_<%= nPops %>" value="Duplicate" onClick="document.pressed=this.value">
		: <input type=text name="name_<%= nPops %>" value="<%= name %>">
	<%
		j = 0;
		while(getParameter("g_"+i+"_"+j,request,h) != null && !getParameter("g_"+i+"_"+j,request,h).trim().equals("")) {
			out.println(" Gate "+(j+1)+":"+printGateList(regions,nPops,j,getParameter("g_"+i+"_"+j,request,h)));
			j++;
		}
		out.println(" Gate "+(j+1)+":"+printGateList(regions,nPops,j,""));
	%>
		<input type=hidden name="cb_<%= nPops %>" value='<%= getParameter("cb_"+i,request,h) %>'>
		<A HREF="#" onClick="popupactivate(document.myform.cb_<%= nPops %>.value,document.myform.cb_<%= nPops %>,'anchor1');return false;" NAME="anchor1" ID="anchor1">Select Files to Gate</A>
		</b></li>

<%		
	}
}
%>
</ul>
<% out.println("<input type=hidden name=\"nPops\" value="+(dup ? nPops+1 : nPops)+">"); %>
<input type=submit value="Add Population" onClick="document.pressed=this.value">
<p>
<input type=submit value="Save & Continue (Gate)" onClick="document.pressed='Gate'">
</form>
</body>

</html>