<%@ page import="java.util.*, FACS.Population, FACS.XMLFiles, FACS.UserTools" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<html>
<head><title>Define Custom Statistics</title>
<script language="JavaScript">
function onSubmitForm() {
	if(document.pressed == "Add Statistic") {
		document.myform.action = "";
	} else {
		document.myform.action = "calc.jsp?dir=<%= request.getParameter("dir") %>&mode=new";
	}
}
</script>
</head>
<body>
<h1>Define Custom Metrics</h1>
<%!
public String printSelect(String name, Vector items) {
	StringBuffer b = new StringBuffer();
	b.append("<select name=\""+name+"\" size=5>");
	for(int i = 0; i < items.size(); i++) {
		b.append("<Option> "+items.elementAt(i).toString()+"\n");
	}
	b.append("</select>");
	return b.toString();
}

public String getParameter(String name, HttpServletRequest request, Hashtable h) {
	if(h == null)
		return request.getParameter(name);
	else
		return (String)h.get(name);
}

public Hashtable getMetrics(String ROOT, String dir) {
	Hashtable h = new Hashtable();
	Hashtable metrics = XMLFiles.getMetrics(ROOT,dir);
	if(metrics == null)
		return null;
	Vector k = new Vector(metrics.keySet());
	Collections.sort(k);
	for(int i = 0; i < k.size(); i++) {
		String key = (String)k.elementAt(i);
		h.put("name_"+i,key);
		h.put("eqn_"+i,(String)metrics.get(key));
	}
	h.put("nPops",k.size()+"");
	return h;
}
%>
<%
String dir = request.getParameter("dir");

Vector pops = XMLFiles.getPopulationsComp(ROOT,dir,false);
%>
<a href="expt.jsp?dir=<%= dir %>">Back</a>
<hr>
Populations:<br>
<%= printSelect("pops",pops) %>
<hr>
<form name="myform" method="post" onSubmit="return onSubmitForm()">
<%
Hashtable h = null;
if(request.getParameter("nPops") == null) //so we don't overwrite the parameters if we already were here
	h = getMetrics(ROOT, dir); //load old populations from pops.xml
int nPops = 1;
if(getParameter("nPops",request,h) != null)
	nPops = new Integer(getParameter("nPops",request,h)).intValue();
if(getParameter("name_"+(nPops-1),request,h) != null && !getParameter("name_"+(nPops-1),request,h).equals(""))
	nPops++;
if(nPops == 0)
	nPops++;
%>

<input type=hidden name="nPops" value="<%= nPops %>">
<ul>
<li><em>Metric name</em> = <em>equation</em><br>
<font size=2>Equation can contain the following key words:
<ul>
<li>Usual mathematical operators and common functions (sin, exp, etc.)</li>
<li>The following custom functions are pre-defined: getRow(), getColumn().<br>
The following statistics are pre-defined: Mean, Median, CV, Percent.</li>
<li>To specify an existing statistic, use the following notation (quotes required): <font size=3>'<em>file</em>'.'<em>population</em>'.'<em>statistic</em>'[.'<em>channel</em>']</font><br>
<em>file</em> may be specified either by the filename or by (<em>row,column</em>), where row and column vary from 0 to (number-1); channel as well may be specified by a name or number (note that not all statistics require/allow a channel). <b>Search for these terms employs regular expressions (first match is returned, with no guarantee of consistency); arithmetic is allowed when specifying files by (<em>row,column</em>).</b>
<li>To invoke the current file (i.e. the one for which the statistic is calculated), specify '<em>file</em>' as '<font size=3><code>File</code></font>', current population as '<font size=3><code>Population</code></font>', and current channel as '<font size=3><code>Channel</code></font>' (capitalization is important here).</li>
<li>Calculations fail gracefully (e.g. files without the requisite population, circular definitions).</li>
</ul>
</font>
<li><b>Example:</b> <code>normalized = 'File'.'Population'.'mean'.'Channel' / '(getRow(),0)'.'Population'.'mean'.'Channel'</code></li>
<li><b>Example:</b> <code>test = 'File'.'B cells'.'mean'.'FL1' / 'Control_1'.'B cells'.'mean'.'FL1'</code>
</li><br>
<%
for(int i = 0; i < nPops; i++) {
	String name = "";
	if(getParameter("name_"+i,request,h) != null)
		name = getParameter("name_"+i,request,h);
	String eqn = "";
	if(getParameter("eqn_"+i,request,h) != null)
		eqn = getParameter("eqn_"+i,request,h);
	%>
	<table><tr><td valign=top><li><input type=text name="name_<%= i %>" value="<%= name %>" size=10> = </td>
	<!--<input type=text name="eqn_<%= i %>" value="<%= eqn %>" size=90>-->
	<td><textarea name="eqn_<%= i %>" cols=90 rows=3><%= eqn %></textarea></td></tr></table>
	</li>
<%
}
%>
</ul>
<input type=submit value="Add Statistic" onClick="document.pressed=this.value">
<p>
<input type=submit value="Save & Calculate" onClick="document.pressed=this.value">
</form>
</body>
</html>