<%@ page import="java.io.*, java.util.*, java.util.regex.*, java.beans.XMLEncoder, FACS.PopStats, FACS.XMLFiles, FACS.UserTools, FACS.Annotator.Plate, org.nfunk.jep.JEP" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<%
String dir = request.getParameter("dir");
//write metrics.xml
if(request.getParameter("mode") != null && request.getParameter("mode").equals("new")) {
	Hashtable metrics = new Hashtable();

	for(int i = 0; i < new Integer(request.getParameter("nPops")).intValue(); i++) {
		String name = request.getParameter("name_"+i);
		String eqn = request.getParameter("eqn_"+i);
		if(!name.equals("") && !eqn.equals("")) {
			metrics.put(name,eqn);
		}
	}
	
	File xml = new File(ROOT+dir,"metrics.xml");
	XMLEncoder xenc = new XMLEncoder(new BufferedOutputStream(new FileOutputStream(xml)));
	xenc.writeObject(metrics);
	xenc.close();
}

standardStats.add("Mean");
standardStats.add("Median");
standardStats.add("Percent");
standardStats.add("CV");
standardStats.add("Number");

//perform actual calculations
Hashtable metrics = XMLFiles.getMetrics(ROOT,dir);
//first, sort stats in order of dependencies
Vector names = new Vector(metrics.keySet());
Hashtable dep = new Hashtable();
for(int i = 0; i < names.size(); i++) {
	String name = (String)names.elementAt(i);
	Vector depend = getDependencies(metrics, names, new Vector(), name, (String)metrics.get(name));
	if(depend == null || depend.contains(name)) {//self-dependent
		names.remove(name);
		continue;
	}
	dep.put(name,depend);
}
DependencyComparator dc = new DependencyComparator(dep);
Collections.sort(names,dc);

plates = XMLFiles.getPlates(ROOT,dir);
params = XMLFiles.getParamNames(ROOT,dir,true);
Vector stats = XMLFiles.readPopStats(ROOT,dir);
for(int i = 0; i < stats.size(); i++) { //for each pop/file
	PopStats ps = (PopStats)stats.elementAt(i);
	for(int j = 0; j < names.size(); j++) { //for each statistic
		String name = (String)names.elementAt(j);
		calcStatistic(stats, name, metrics, ps);
	}
}

File xml = new File(ROOT+dir,"stats.xml");
xml.delete();
try { //write each region to XML file
	FileOutputStream fos = new FileOutputStream(xml);
	XMLEncoder xenc = new XMLEncoder(fos);
	xenc.setExceptionListener(new java.beans.ExceptionListener() {
		public void exceptionThrown(Exception exception) {
			exception.printStackTrace();
		}
	});
	for(int i = 0; i < stats.size(); i++) {
		xenc.writeObject(stats.elementAt(i));
		xenc.flush();
	}
	xenc.close();
	fos.close();
} catch (FileNotFoundException e) {
	e.printStackTrace();
}

%>
<html><head><title>Calculations complete!</title></head>
<body>
<h1>Calculations complete</h1>
<a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a>
</body></html>
<%!
public static Vector standardStats = new Vector();

public Vector getDependencies(Hashtable metrics, Vector names, Vector parent, String name, String eqn) {
	//two types of patterns, first look for 4-length
	eqn = " "+eqn; //so we don't have to worry about beginning of line
	Matcher m = Pattern.compile("[^.]('[^']+'.'[^']+'.'[^']+')").matcher(eqn);
	while(m.find()) {
		String term = m.group(0);
		String[] pcs = term.split("'.'");
		pcs[2] = pcs[2].substring(0,pcs[2].length()-1);
		if(getProperNameStrict(standardStats,pcs[2]) == null) {
			String proper = getProperNameStrict(names,pcs[2]);
			if(proper == null) //statistic does not exist (or was self-dependent...)
				return null;
			parent.add(proper);
			if(proper.equals(name)) //self-dependent! we need not look any farther
				return parent;
			getDependencies(metrics, names, parent, proper, (String)metrics.get(proper));
		}
	}
	return parent;
}

public String getProperNameStrict(Vector table, String in) {
	for(int i = 0; i < table.size(); i++) {
		if(((String)table.elementAt(i)).equalsIgnoreCase(in))
			return (String)table.elementAt(i);
	}
	return null;
}
%>
<%!
Vector plates = null;
Vector params = null;

class DependencyComparator implements Comparator {
	Hashtable dep;

	public DependencyComparator(Hashtable dep) {
		this.dep = dep;
	}

	public int compare(Object o1, Object o2) throws ClassCastException {
		String s1 = (String)o1;
		String s2 = (String)o2;
		Vector dep1 = (Vector)dep.get(s1);
		Vector dep2 = (Vector)dep.get(s2);
		if(dep1 == null || dep2 == null)
			throw new ClassCastException();
		if(dep1.size() < dep2.size())
			return -1;
		if(dep1.size() > dep2.size())
			return 1;
		if(dep2.contains(s1))
			return -1;
		if(dep1.contains(s2))
			return 1;
		return 0;
	}
}

class UnreadyException extends Exception {
	public PopStats ps;
	public String stat;

	public UnreadyException(PopStats ps, String stat) {
		this.ps = ps;
		this.stat = stat;
	}
}
%>
<%!
public void calcStatistic(Vector stats, String name, Hashtable metrics, PopStats ps) {
	String eqn = (String)metrics.get(name);
	String[] channels = new String[0];
	try { //try to calculate
		channels = enterValues(stats, ps, eqn);
	} catch (UnreadyException ue) { //found a stat we didn't have
		Vector errs = new Vector();
		int i = 0;
		while((i++) < metrics.size()) { //keep trying; fail if we recycle a statistic
			String properStat = getProperStatName(metrics.keys(),ue.stat);
			if(properStat == null)
				return;
			if(errs.contains(properStat))
				return;
			errs.add(properStat);
			calcStatistic(stats, properStat, metrics, ue.ps);
			try {
				channels = enterValues(stats,ps,eqn);
				break;
			} catch (UnreadyException ue2) {
				ue=ue2;
			}
		}
	}
	if(channels.length == 0)
		return;
	double[] vals = new double[channels.length];
	org.nfunk.jep.JEP myParser = new org.nfunk.jep.JEP();
	myParser.addStandardFunctions();
	myParser.addStandardConstants();
	for(int c = 0; c < channels.length; c++) {
		myParser.parseExpression(channels[c]);
		vals[c] = myParser.getValue();
	}
	ps.setStat(name,vals);
}

public String[] enterValues(Vector stats, PopStats ps, String eqn) throws UnreadyException { //failure results in returning String[0]
	//UnreadyException thrown only if fail to find stat (i.e. possibility that we can fix)
	//replace getRow(), getColumn()
	Matcher m1 = Pattern.compile("getRow\\(\\)").matcher(eqn);
	Matcher m2 = Pattern.compile("getColumn\\(\\)").matcher(eqn);
	if(m1.find() || m2.find()) {
		int[] rc = getRC(ps.getFile());
		if(rc == null)
			return new String[0];
		eqn = eqn.replaceAll("getRow\\(\\)",rc[0]+"");
		eqn = eqn.replaceAll("getColumn\\(\\)",rc[1]+"");
	}
	//figure out if eqn has Channel, then split into requisite number of equations
	Matcher mCh = Pattern.compile("Channel").matcher(eqn);
	String[] eqns;
	if(mCh.find()) {
		eqns = new String[ps.getSize()];
		for(int i = 0; i < eqns.length; i++) {
			eqns[i] = eqn.replaceAll("Channel",(i+1)+"");
		}
	} else {
		eqns = new String[1];
		eqns[0] = eqn;
	}

	org.nfunk.jep.JEP myParser = new org.nfunk.jep.JEP();
	myParser.addStandardFunctions();
	myParser.addStandardConstants();	
	
	boolean applies = false; //statistic refers to this file
	for(int c = 0; c < eqns.length; c++) { //for each channel (possibly only 1)
		String temp = eqns[c];
		Matcher m = Pattern.compile("(('[^']+'.){2,3}'[^']+')").matcher(eqns[c]);
		while(m.find()) { //for each variable
			String var = m.group(0);
			String[] pcs = var.split("'.'");
			String file = pcs[0].substring(1); String pop = pcs[1];
			String stat = pcs[2];
			if(pcs.length == 3)
				stat = stat.substring(0,stat.length()-1); //problem with leftover '
			String chan = "";
			if(pcs.length > 3)
				chan = pcs[3].substring(0,pcs[3].length()-1);

			//calculate entries of (,) if necessary, then get file from that
			Matcher mparen = Pattern.compile("\\(([^,]+),([^\\)]+)\\)").matcher(file);
			if(mparen.matches()) {
				String rowS = mparen.group(1); String colS = mparen.group(2);
				myParser.parseExpression(rowS);
				int row = (int)myParser.getValue();
				myParser.parseExpression(colS);
				int col = (int)myParser.getValue();
				file = getFile(ps.getFile(),row,col);
			} else if(file.equals("File")) {
				file = ps.getFile();
			} else {
				file = getProperFileName(stats,file);
			}
			//figure out if it contains a reference to the current file
			if(file == null)
				return new String[0];
			if(file.equals(ps.getFile()))
				applies = true;
			
			//figure out if file contains the specified population
			if(pop.equals("Population"))
				pop = ps.getPop();
			PopStats popPS = getProperPopName(stats, file, pop);
			if(popPS == null)
				return new String[0];
			pop = popPS.getPop();
			
			//plug in numbers
			String statOld = stat;
			stat = getProperStatName(popPS, stat);
			if(stat == null)
				throw new UnreadyException(popPS,statOld);
			Matcher mletter = Pattern.compile("\\D").matcher(chan);
			if(mletter.find()) {
				chan = getProperChannelNumber(params,chan);
			}
			int ch;
			if(chan.equals("")) {
				ch = 0;
			} else {
				try {
					ch = new Integer(chan).intValue()-1;
				} catch (NumberFormatException nfe) {
					return new String[0];
				}
			}

			double value;
			try {
				value = popPS.getStat(stat)[ch];
			} catch (ArrayIndexOutOfBoundsException aioobe) { //requested channels from a non-channel parameter
				return new String[0];
			}

			temp = temp.replaceAll(Pattern.quote(var),value+"");
		}
		if(!applies)
			return new String[0];
		eqns[c] = temp;
	}
	return eqns;
}

public int[] getRC(String file) { //get row,column position of a given file
	for(int i = 0; i < plates.size(); i++) {
		int n = ((Plate)plates.elementAt(i)).getData().indexOf(file);
		if(n == -1)
			continue;
		return ((Plate)plates.elementAt(i)).getRC(n);
	}
	return null;
}

public String getFile(String basefile, int row, int col) { //get file name from row, col (basefile determines plate)
	for(int i = 0; i < plates.size(); i++) {
		Plate p = (Plate)plates.elementAt(i);
		int n = p.getData().indexOf(basefile);
		if(n == -1)
			continue;
		try {
			return (String)p.getData().elementAt(p.getIndex(row,col));
		} catch (ArrayIndexOutOfBoundsException aioobe) {
			return null;
		}
	}
	return null;
}

public String getProperFileName(Vector stats, String name) {
	Pattern p = Pattern.compile(Pattern.quote(name),Pattern.CASE_INSENSITIVE);
	for(int i = 0; i < stats.size(); i++) {
		String file = ((PopStats)stats.elementAt(i)).getFile();
		if(p.matcher(file).find())
			return file;
	}
	return null;
}

public PopStats getProperPopName(Vector stats, String file, String name) {
	Pattern p = Pattern.compile(Pattern.quote(name),Pattern.CASE_INSENSITIVE);
	for(int i = 0; i < stats.size(); i++) {
		PopStats ps = (PopStats)stats.elementAt(i);
		String psfile = ps.getFile();
		if(!psfile.equals(file))
			continue;
		String pop = ps.getPop();
		if(p.matcher(pop).find())
			return ps;
	}
	return null;
}

public String getProperStatName(PopStats ps, String name) {
	return getProperStatName(ps.getStatNames(),name);
}

public String getProperStatName(Enumeration e, String name) {
	Pattern p = Pattern.compile(Pattern.quote(name),Pattern.CASE_INSENSITIVE);
	while(e.hasMoreElements()) {
		String stat = (String)e.nextElement();
		if(p.matcher(stat).find())
			return stat;
	}
	return null;
}

public String getProperChannelNumber(Vector params, String name) {
	Pattern p = Pattern.compile(Pattern.quote(name),Pattern.CASE_INSENSITIVE);
	for(int i = 0; i < params.size(); i++) {
		if(p.matcher((String)params.elementAt(i)).find())
			return (i+1)+"";
	}
	return "";
}

%>