<%--gating page for compensation (user came from Compensation.jsp)--%>
<%--this page forwards to cstatus.jsp after it writes the populations in pops.xml--%>
<%@ page import="java.beans.XMLDecoder, java.io.*, java.util.Vector, java.util.Hashtable, FACS.Population, FACS.PopStats, FACS.XMLFiles, FACS.UserTools, FACS.Plot.Region" %>
<%!
public double[] zeroes(int len) {
	double[] out = new double[len];
	for(int i = 0; i < out.length; i++) {
		out[i] = 0d;
	}
	return out;
}

public double[][] zeroes(int len1, int len2) {
	double[][] out = new double[len1][len2];
	for(int i = 0; i < len1; i++) {
		out[i] = zeroes(len2);
	}
	return out;
}
%>
<%!
public Vector getRegions(String ROOT, String dir) {
	Vector regions = new Vector();
	try {
		File xml = new File(ROOT+dir,"regions.xml");
		XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
		d.setExceptionListener(new java.beans.ExceptionListener() {
			public void exceptionThrown(Exception exception) {
				exception.printStackTrace();
			}
		});
		while(true) {
			try {
				regions.add((Region)d.readObject());
			} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
				d.close();
				break;
			}
		}
	} catch (IOException ioe) {
		ioe.printStackTrace();
	}
	return regions;
}

public boolean regionExists(Vector regions, String name) {
	for(int i = 0; i < regions.size(); i++) {
		if(((Region)regions.elementAt(i)).getName().equals(name))
			return true;
	}
	return false;
}
%>

<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<%
File xml;

boolean COMP_ALL = false;
boolean universal = false;
String dir = request.getParameter("dir");
Vector pops = new Vector();
if(request.getParameter("mode") != null && request.getParameter("mode").equals("new")) { //came from Compensation.jsp
	Vector regions = getRegions(ROOT,dir);

	if(!request.getParameter("pN").equals("")) {
		if(regionExists(regions,"pN")) {
			Vector gates = new Vector();
			gates.add("pN");
			Vector files = new Vector();
			files.add(request.getParameter("pN"));
			pops.add(new Population("pN", gates, files, false));
			universal = true;
		}
	}

	for(int i = 0; i < new Integer(request.getParameter("nPops")).intValue(); i++) {
		//only generate populations for those we will actually gate - namely, those with + & - populations
		if(request.getParameter("p"+i+"P").equals("") || (request.getParameter("p"+i+"N").equals("") && request.getParameter("pN").equals("")))
			continue;

		//check to make sure a region exists for this population
		if(!regionExists(regions,"p"+i+"P") || (!regionExists(regions,"p"+i+"N") && !universal)) {
			%>
			<html><head><title>Error</title></head>
			<body>
			<h1>Error</h1>
			Compensation gate(s) not defined for parameter <%= i+1 %>. <a href="Compensation.jsp?dir=<%= dir %>">Go Back.</a>
			<%
			return;
		}

		Vector gatesP = new Vector();
		gatesP.add("p"+i+"P");
		Vector gatesN = new Vector();
		if(universal)
			gatesN.add("pN");
		else
			gatesN.add("p"+i+"N");

		Vector filesP = new Vector(); //generally filesP == filesN
		filesP.add(request.getParameter("p"+i+"P"));
		Vector filesN = new Vector();
		if(universal)
			filesN.add(request.getParameter("pN"));
		else
			filesN.add(request.getParameter("p"+i+"N"));

		pops.add(new Population("p"+i+"P", gatesP, filesP, false));
		pops.add(new Population("p"+i+"N", gatesN, filesN, false));
	}
%><%
	//read pops.xml, then replace/add compensation populations & save
	Vector total = XMLFiles.getPopulationsComp(ROOT,dir,false);

	for(int i = 0; i < total.size(); i++) {
		Population pi = (Population)total.elementAt(i);
		for(int j = 0; j < pops.size(); j++) {
			Population pj = (Population)pops.elementAt(j);
			if(pi.getName().equals(pj.getName())) {
				total.removeElementAt(i);
				i--;
				break;
			}
		}
	}
	total.addAll(pops);
	XMLFiles.savePops(ROOT,dir,total);
}

%><%
if(request.getParameter("mode") != null && request.getParameter("mode").equals("done")) { //compensation samples gated, now calculate matrix, then re-gate to display new medians...
	//calculate spillover matrix (inverse of comp matrix)
	Vector stats = XMLFiles.readPopStats(ROOT,dir);
	int nParams = XMLFiles.getParamNumber(ROOT,dir);
	double[][] c = zeroes(nParams,nParams);
	for(int i = 0; i < nParams; i++) { //iterate over parameters, looking for ones that have defined positives
		PopStats psP = XMLFiles.getStatsByPop(stats,"p"+i+"P",false);
		PopStats psN = XMLFiles.getStatsByPop(stats,"p"+i+"N",false);
		c[i][i] = 1.0;
		if(psP == null || psN == null)
			continue;
		for(int j = 0; j < nParams; j++) { //get the negative pop
			if(j == i) {
				continue;
			}
			if(!COMP_ALL) {
				if(XMLFiles.getStatsByPop(stats,"p"+j+"P",false) == null) //only compensate against parameters for which user has specified comps
					continue;
			}
				//from comp matrix (OLD) way...
				/*//okay, now we have a pair of positive(i) and negative(j) populations
				//calculation is for compensating "NEG - c*POS"
				//c[j][i] = -(psP.getMedian()[j] - psN.getMedian()[j]) / (psP.getMedian()[i] - psN.getMedian()[i]);
				//c[j][i] = -(psP.getMean()[j] - psN.getMean()[j]) / (psP.getMean()[i] - psN.getMean()[i]);*/

			//spillover calc kij = bleed of j into i = obs(i)/obs(j) in j-positive... so switch the indices
			//c[j][i] = psP.getMean()[j] / psP.getMean()[i];
			c[j][i] = (psP.getMean()[j] - psN.getMean()[j]) / (psP.getMean()[i] - psN.getMean()[i]);
		}
	}
	/*System.out.println(" ");

	for(int i = 0; i < c.length; i++) {
		for(int j = 0; j < c.length; j++)
			System.out.print(c[i][j]+"\t");
		System.out.println(" ");
	}*/

	c = invertMatrix(c);
	//matrix inversion here is APPROXIMATELY equal to making non-diagonals negative (but not quite!)
	/* make positive non-diagonal elements 0 ('positive' compensation); also diagonals = 1 */
	for(int i = 0; i < nParams; i++) {
		for(int j = 0; j < nParams; j++) {
			if(i==j)
				c[i][j] = 1d;
			else if(c[i][j] > 0)
				c[i][j] = 0d;
		}
	}

	/*System.out.println(" ");

	for(int i = 0; i < c.length; i++) {
		for(int j = 0; j < c.length; j++)
			System.out.print(c[i][j]+"\t");
		System.out.println(" ");
	}*/

	//save compensation matrix
	XMLFiles.saveComp(ROOT,dir,c);

	//deal with populations (new compensated versions)
	Vector total = new Vector();
	xml = new File(ROOT+dir,"pops.xml");
	XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
	d.setExceptionListener(new java.beans.ExceptionListener() {
		public void exceptionThrown(Exception exception) {
			exception.printStackTrace();
		}
	});
	while(true) {
		try {
			Population p = (Population)d.readObject();
			if(!p.getName().matches("^p\\d[PN]$")) {
				total.add(p);
			} else if(p.getName().matches("^p\\d[PN]$") && !p.isComp()) { //add new populations that are compensated versions of comp gates
				total.add(p);
				Population pc = p.deriveCompensated();
				total.add(pc);
				pops.add(pc);
			}
		} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
			d.close();
			break;
		}
	}
	XMLFiles.savePops(ROOT,dir,total);
}
%>

<%!
public double[][] invertMatrix(double[][] c) {
	//this performs the Shipley-Coleman inversion algorithm
	//THIS FUNCTION MODIFIES ITS ARGUMENT!

	for(int k = 0; k < c.length; k++) {
		c[k][k] = -1/c[k][k]; //"pivot" element = diagonal
		for(int i = 0; i < c.length; i++) { //column
			if(i != k)
				c[i][k] *= c[k][k];
		}
		for(int i = 0; i < c.length; i++) { //non-row/column
			if(i != k) {
				for(int j = 0; j < c.length; j++) {
					if(j != k)
						c[i][j] += c[i][k] * c[k][j];
				}
			}
		}
		for(int i = 0; i < c.length; i++) { //row
			if(i != k)
				c[k][i] *= c[k][k];
		}
	}

	for(int i = 0; i < c.length; i++) { //invert sign
		for(int j = 0; j < c.length; j++)
			c[i][j] = -c[i][j];
	}

	return c;
}
%>

<%//actual gating
 session.removeAttribute("comptask"); %>

<jsp:useBean id="comptask" scope="session"
    class="FACS.GaterBean"/>

<% 
comptask.setPops(pops); //only do compensation populations
comptask.setDir(ROOT,dir);
comptask.setRunning(true);
%>

<% new Thread(comptask).start(); %>

<jsp:forward page="cstatus.jsp"/>
