<%--intermediate status page for compensation operation (user came from cgate.jsp)--%>
<%@ page import="java.io.*, java.util.Vector, java.util.Hashtable, FACS.Population, FACS.PopStats, FACS.XMLFiles" %>
<jsp:useBean id="comptask" scope="session"
    class="FACS.GaterBean"/>
<% 
if(comptask == null) {
	response.sendRedirect("expt.jsp?dir="+request.getParameter("dir"));
}
if (comptask.isRunning()) { %>
	<html><head>
	<title>Gating...</title>
	<SCRIPT LANGUAGE="JavaScript">
		setTimeout("location='cstatus.jsp?dir=<%= request.getParameter("dir") %>&mode=<%= request.getParameter("mode") %>'", 1500);
	</SCRIPT>
<% } else {
	if(request.getParameter("mode").equals("new")) { //compensation finished... redirect to cgate to re-gate & calculate new medians 
		String s = "cgate.jsp?dir="+request.getParameter("dir")+"&mode=done";
		%>
		<jsp:forward page="<%= s %>"/> 
<%	} else { //compensation AND re-gating finished %>
<%	}
} %>
</head>
<body>

<h1 align="center">Compensation Gating Progress:</h1>
<h2 align="center">
<%
if(request.getParameter("mode").equals("new")) {
	%>
	Calculating compensation matrix...
	<%
} else {
	%>
	Calculating post-compensation statistics...
	<%
} %>
</h2>


<h3 align="center">
<% int percent = comptask.getPercent(); %>
	<p>(<%= comptask.getTimeElapsed() %> ms elapsed out of est. <%= comptask.getTimeLeft() %> ms remaining).<br>
	    <%= percent %>%
</h3>

<table width="60%" align="center"
        border="1" cellpadding="0" cellspacing="2">
    <TR>
        <% for (int i = 10; i <= percent; i += 10) { %>
            <td width="10%" bgcolor="#000080">&nbsp;</td>
        <% } %>
        <% for (int i = 100; i > percent; i -= 10) { %>
            <td width="10%">&nbsp;</TD>
        <% } %>
    </tr>
</table>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
    <tr>
        <td align="center">
            <% if (comptask.isRunning()) { %>
                Running
            <% } else { %>
                <% if (comptask.isCompleted() && request.getParameter("mode").equals("done")) { %>
                    Completed
                <% } else if (!comptask.isStarted()) { %>
                    Not Started
                <% } else { %>
                    Stopped
                <% } %>
            <% } %>
        </td>
    </tr>
<table>

<% if(comptask.isRunning() || !(comptask.isCompleted() && request.getParameter("mode").equals("done"))) {
	return;
} %>

<% //okay, let's tell the user what we did
String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}
boolean COMP_ALL = false;
String dir = request.getParameter("dir");

Vector stats = XMLFiles.readPopStats(ROOT,dir);
Hashtable annos = XMLFiles.getPAnnos(ROOT,dir,true);
int nParams = XMLFiles.getParamNumber(annos);
%>
<b><a href="expt.jsp?dir=<%= request.getParameter("dir") %>">Back</a></b><p>
<table width=100% >
<tr>
<td>
<h3 align="left">Post-Compensation Means:</h3>
<table border cellspacing=0 width=100% >
<tr>
<td><b>Parameter</b></td><td></td><td><p align=center><font size=5><em>+ve</em></font></p></td>
<td><p align=center><font size=5><em>-ve</em></font></p></td>
</tr>
<% //print out statistics (medians)
Vector pops = XMLFiles.getPopulations(ROOT,dir);
Vector files = new Vector();
Vector fparams = new Vector();
Hashtable fileparams = new Hashtable();
PopStats pN = XMLFiles.getStatsByPop(stats,"pN",true);
for(int i = 0; i < nParams; i++) { //iterate over parameters, looking for ones that have defined positives
	PopStats psP = XMLFiles.getStatsByPop(stats,"p"+i+"P",true);
	PopStats psN = XMLFiles.getStatsByPop(stats,"p"+i+"N",true);
	if(psP == null || (psN == null && pN == null))
		continue;
	if(psN == null)
		psN = pN;
	for(int j = 0; j < nParams; j++) {
		if(i == j)
			continue;
		if(!COMP_ALL) {
			if(XMLFiles.getStatsByPop(stats,"p"+j+"P",true) == null)
				continue;
		}

		String pname1 = (String)annos.get("P"+(i+1));
		String pname2 = (String)annos.get("P"+(j+1));

		//for plot chooser
		String filename = XMLFiles.getFileByPop(pops,"p"+i+"P");
		files.add(filename);
		fparams.add(pname1+" into "+pname2);
		fileparams.put(pname1+" into "+pname2,i+","+j);

		%>
		<tr>
		<td><%= ("P"+(i+1)+": ") %> <b><%= pname1 %></b> into <%= ("P"+(j+1)+": ") %> <b><%= pname2 %></b></td>
		<td><p align=right><%= pname2 %>:</p></td>
		<td><p align=right><%= round(psP.getMean()[j],2) %></p></td>
		<td><p align=right><%= round(psN.getMean()[j],2) %></p></td>
		</tr>
<%
	}
}
%>
</table>
</td>
<td>
<form name="plotform" method="post" action="">
<% //let user look at compensated plots
int f = 0;
if(request.getParameter("i") != null)
	f = new Integer(request.getParameter("i")).intValue();
String params = (String)fileparams.get(fparams.elementAt(f));
out.println("<p align=center>"+printFileSelect(fparams,files,f));
boolean comp = (request.getParameter("comp") != null && request.getParameter("comp").equals("true"));
boolean comp2 = (request.getParameter("i") == null || comp);
%>
<input type=checkbox name="comp" value="true" <%= comp2 ? "checked" : "" %> onClick="document.plotform.submit()">Compensated</p>
</form>
<applet code="FACS.Plot.PlotApplet.PlotApplet.class" archive="PlotApplet.jar" width=350 height=350>
<!--<param name="host" value="localhost">-->
<param name="port" value="4455">
<param name="directory" value="<%= dir %>">
<param name="file" value="<%= (String)files.elementAt(f) %>">
<param name="param1" value=<%= params.split(",")[0] %> >
<param name="param2" value=<%= params.split(",")[1] %> >
<param name="mode" value=1>
<param name="compact" value="true">
<% if(comp2) { %>
	<param name="comp" value="true">
<% } else { %>
	<param name="comp" value="false">
<% } %>
</applet>
</p>
</td>
</tr>
</table>
<h3>
Compensation Matrix: </h3>
<form name="compform" action="changecomp.jsp?dir=<%= request.getParameter("dir") %>" method="post">
<input type=hidden name="nPops" value="<%= nParams %>">
<table border=1 cellspacing=0 width=100% >
<% //let user see and manipulate comp matrix
double[][] c = XMLFiles.getComp(ROOT,dir);

out.println("<tr><td></td>");
for(int i = 0; i < c.length; i++) {
	out.println("<td><font size=2>"+(String)annos.get("P"+(i+1))+"</font></td>");
}
out.println("</tr>");

for(int i = 0; i < c.length; i++) {
	out.println("<tr>");
	out.println("<td><p align=right>"+(String)annos.get("P"+(i+1))+"=</p></td>");
	for(int j = 0; j < c.length; j++) {
		out.println("<td><input type=text name=\""+i+","+j+"\" size=3 style=\"text-align:right\" value="+round(c[i][j]*100d,2)+">%</td>");
	}
	out.println("</tr>");
}
%>
</table>
<input type=submit value="Change Matrix">
</form>
</h3>
<%!

public String round(double in, int dec) {
	in *= Math.pow(10,dec);
	double out = ((double)((int)in))/Math.pow(10,dec);
	return new Double(out).toString();
}

public String printFileSelect(Vector names, Vector values, int index) {
	StringBuffer b = new StringBuffer();
	b.append("<input type=hidden name=\"i\" value=\""+index+"\">");
	b.append("<Select name=\"iselect\" onChange=\"document.plotform.i.value=document.plotform.iselect.value.split('?')[1]; document.plotform.submit();\">\n");
	for(int i = 0; i < names.size(); i++) {
		String r = (String)names.elementAt(i);
		if(i == index)
			b.append("<Option selected value=\""+(String)values.elementAt(i)+"?"+i+"\"> "+r+"\n");
		else
			b.append("<Option value=\""+(String)values.elementAt(i)+"?"+i+"\"> "+r+"\n");
	}
	b.append("</Select>");
	return b.toString();
}

%>
</body>
</html>