<%@ page import="FACS.UserTools, java.io.File" %>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

if(UserTools.isSampleExperiment(request.getParameter("dir"))) {
	response.sendRedirect("Duplicate.jsp?dir="+request.getParameter("dir")+"&auto=true");
	return;
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm == UserTools.NO_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<html><head>
<%
String dir = request.getParameter("dir");
boolean higher_than_view = perm > UserTools.VIEW_PERM;
%>
<title>WebFlow - Experiment: <%= dir %></title>
</head>
<body>
<h1>WebFlow<p>Experiment: <%= dir %></h1>
<a href="index.jsp">Back to Experiment List</a>
<% if(perm > UserTools.EDIT_PERM) { //need ADMIN permission to edit other users' permissions%>
	<h3><a href="User.jsp?dir=<%= dir %>">Edit user permissions.</a></h3>
<% } %>
<h3>Analyze your experiment:</h3>
<font size=4>
<ol>
<% if(higher_than_view) { %>
	<li><a href="Annotator.jsp?dir=<%= dir %>">Annotate Experiment</a> (<a href="Annotate.htm"><img src="question.gif"></a>)</li>
	<li><a href="Compensation.jsp?dir=<%= dir %>">Set Up Compensation</a>  (<a href="Comp.htm"><img src="question.gif"></a>)</li>
<% } %>
<li><a href="PlotPlate.jsp?dir=<%= dir %>">View FACS Plots and Design Gates</a> (<a href="Gates.htm"><img src="question.gif"></a>)</li>
<% if(higher_than_view) { %>
	<li><a href="Populations.jsp?dir=<%= dir %>">Define Populations / Gate</a> (<a href="Populations.htm"><img src="question.gif"></a>)</li>
<% } %>
<li><a href="PopView.jsp?dir=<%= dir %>">View Populations</a></li>
<% if(higher_than_view) { %>
	<li><a href="Statistic.jsp?dir=<%= dir %>">Define Custom Statistics</a></li>
<% } %>
<li><a href="HeatPlate.jsp?dir=<%= dir %>">View Heat Map</a></li>
<li><a href="PlotPrint.jsp?dir=<%= dir %>">Print Plots</a></li>
<li><a href="Export.jsp?dir=<%= dir %>">Export Data As A List</a></li>
<li><a href="HeatList.jsp?dir=<%= dir %>">View Heat Map List</a></li>
<li><a href="MetaAnalysis.jsp?dir=<%= dir %>">Meta-Analysis</a></li>
<%
File rchanged = new File(new File(ROOT,dir),"rchanged.xml");
if(rchanged.exists() && higher_than_view) {
%>
	<li><em><a href="gate.jsp?dir=<%= dir %>&mode=update">Update Populations with Changed Gates</a></em></li>
<% } %>
</ol></font>
<% if(higher_than_view) { %>
	<h3><a href="Clear.jsp?dir=<%= dir %>">Clear Analysis</a></h3><p>
<% } %>
<% if(higher_than_view) { %>
	<h3><a href="Duplicate.jsp?dir=<%= dir %>">Duplicate Experiment</a></h3><p>
<% } %>
<a href="login.jsp">Logout</a>
</body>
</html>